// a header file for the configuration  service
#ifndef CSDATA_INCLUDED
#define CSDATA_INCLUDED
#include <srltpt.h>
#include <dxxxlib.h>
#include <dxxxlow.h>
#include "pbxtypes.h"

#ifdef __cplusplus 
extern "C" {
#endif

// Bitmap flags for the csConfigDialog argument
#define		CSGUI_AUTOSAVE			0x1000000
#define		CSGUI_BDINFO_PAGE		0x0000001
#define		CSGUI_CALLPARMS_PAGE	0x0000002
#define		CSGUI_DISCTONES_PAGES	0x0000004
#define		CSGUI_GENTONE_PAGE		0x0000008
#define		CSGUI_PBXSTRINGS_PAGE	0x0000010
#define		CSGUI_ANALOG_PAGES		0x000001f
#define		CSGUI_DTI_PROTOCOLS_PAGE	0x0000020
#define		CSGUI_MSI_PAGE			0x0000040	//
#define		CSGUI_FAXTONE_PAGE		0x0000080	// PS 8/11/98 - required by DTI line types.

// Structures types
//#define CS_DESCRIPTOR	80000000L	// descriptor
//#define CS_MASTER		0L	// Master descriptor; defined in csapi.h
#define CS_CATN			1L	// call analysis tones 
#define CS_TN_GEN		3L	// TN_GEN;
#define CS_BDPARMS		4L	// Board parms
#define CS_CPPARMS		5L	// Call parms
#define CS_PBXPARMS		6L	// PBX config (forward, park, hold etc)
#define CS_DISCTN1		7L	// disconnect tones 
#define CS_DISCTN2		8L	// disconnect tones 
#define CS_DISCTN3		9L	// disconnect tones 
#define CS_DISCTN4		10L	// disconnect tones 
// MRF
#define CS_FAXTONE1		11L // fax cng tone
// MRF
//	and so on. . .
#define CS_USER			65536L // everything above is user-defined data
// TAPI ?

// a minor problem: TN_TEMPL has min & max freqs, all the functions have freq & deviation 
typedef struct _cscatn {	// call analysis tones
	TN_TMPLT TnLCL;			// TID_DIAL_LCL          250
	TN_TMPLT TnINTL;		// TID_DIAL_INTL         251
	TN_TMPLT TnXTRA;		// TID_DIAL_XTRA         252
	TN_TMPLT TnBUSY1;		// TID_BUSY1             253
	TN_TMPLT TnRNGBK1;		// TID_RNGBK1            254
	TN_TMPLT TnBUSY2;		// TID_BUSY2             255
	TN_TMPLT TnRNGBK2;		// TID_RNGBK2            256
	TN_TMPLT TnFAX1;		// TID_FAX1              258
	TN_TMPLT TnFAX2;		// TID_FAX2              259
} CSCATN, *PCSCATN;

typedef struct _csdisctn {	
	TN_TMPLT TnTmplt[2];
} CSDISCTN, *PCSDISCTN;

// disconnect tones
#define nIdTNDEF_FREQ1		0	// Freq 1
#define nIdTNDEF_FDEV1		1	// Deviation 1
#define nIdTNDEF_FREQ2		2	// Freq 2
#define nIdTNDEF_FDEV2		3	// Deviation 2
#define nIdTNDEF_ONT		4	// On time
#define nIdTNDEF_ONDEV		5	// On time deviation
#define nIdTNDEF_OFFT		6	// Off time
#define nIdTNDEF_OFFDEV		7	// Off time deviation
#define nIdTNDEF_REPCOUNT	8	// Rep count
#define nIdTNDEF_MAX		nIdTNDEF_REPCOUNT + 1

typedef struct _cstndefs {	// dual tone definitions
	unsigned int nTNDEF[nIdTNDEF_MAX];
} CSTNDEFS, *PCSTNDEFS;

typedef struct _cstnstor {
	DWORD dwIndex; 
	CSTNDEFS pcsTnDefs[2];
} CSTNSTOR, *PCSTNSTOR;

//MRF I think we need a storage location for CS_FAXTONE1
typedef struct _csfaxtnstor {
	DWORD dwIndex;
	CSTNDEFS pcsFaxTnDefs[2];
} CSFAXTNSTOR, *PCSFAXTNSTOR;
//MRF

// Custom tones such as beep
typedef struct _cstongen {
	TN_GEN	TonGen;		
} CSTNGEN, *PCSTNGEN;

typedef struct _cstngenstor {
	DWORD dwIndex; 
	TN_GEN pcsTnGen[2];
} CSTNGNSTOR, *PCSTNGNSTOR;

// Board parameters
#define nIdDXBD_TTDATA		0	// Length of DTMF digit for dialing	(10)
#define nIdDXBD_FLASHTM		1	// Flash time during dialing 		(50)
#define nIdDXBD_PAUSETM		2	// Pause time during dialing 		(200)
#define nIdDXBD_P_MK		3	// Length of pulse dialing make 	(4)
#define nIdDXBD_P_BK		4	// Length of pulse dialing break 	(6)
#define nIdDXBD_P_IDD		5	// Length of pulse inter digit delay(100)
#define nIdDXBD_T_IDD		6	// Length of TT inter digit delay 	(5)
#define nIdDXCH_DTMFTLK		7	// DTMF anti-talkoff during playback 
#define nIdDXCH_DTMFDEB		8	// DTMF debounce time 
#define nIdDXBD_MAX			nIdDXCH_DTMFDEB + 1

typedef struct _csbdparms {
	int nDXBDPL[nIdDXBD_MAX];
} CSBDPARMS, *PCSBDPARMS;

typedef struct _csbdstor {
	DWORD dwIndex; 
	CSBDPARMS pcsBDParms[2];
} CSBDSTOR, *PCSBDSTOR;

// Call parameters
	#define nEnbPerfCall		0	// Enable Perfect Call				(1)
	#define nIdDXBD_R_ON		1	// Min time for ring detection		(3)
	#define nIdDXBD_R_OFF		2	// Min time for for the end of a ring (5)
	#define nIdDXBD_R_IRD		3	// Max wait between rings			  (80)
	#define nIdDXBD_MINLCOFF	4	// Min time of lc off before message  (0)
//MRF moved this as some code expects all CP? parms to be together and between R_ON and RINGCNT
//as in cd41intf.cpp line 875	AIM: changed bcak, because RB_TO is not really a board level parm
//MRF
	#define nIdDXCH_RINGCNT		5	// Per channel ring count (1)
	#define nIdDXBD_RB_TO		6
// MRF
////	#define	nIdMaxRings			6
	#define nPerfFeature		7
	#define	nIdMaxRings			8
	#define nIdCP_MAX			nIdMaxRings + 1
// MRF

typedef struct _cscallparms {
	int nCPPL[nIdCP_MAX];
} CSCALLPARMS, *PCSCALLPARMS;

typedef struct _cscpstor {
	DWORD dwIndex; 
	CSCALLPARMS pcsCPParms[2];
} CSCPSTOR, *PCSCPSTOR;

typedef struct _cspbxstor {
	PBXSTRINGS csPbxStrings;
} CSPBXSTOR, *PCSPBXSTOR;

typedef struct _cswpbxstor {
	WPBXSTRINGS csPbxStrings;
} CSWPBXSTOR, *PCSWPBXSTOR;


#ifdef __cplusplus 
}
#endif

#endif // CSDATA_INCLUDED

// DX_CAP ;
// TN_GEN;
// Board parms
// Channel parms
// PBX config (forward, park, hold etc)
// TAPI ?

// These are out
//	int nDXBD_OFFHDLY;		// Delay before offhook finished 
//	int nDXBD_MINOFFHKTM;	// Minimum off-hook time 
//	int nDXBD_MAXPDOFF;		// Max time for lc off for LPD 
//	int nDXBD_MINISL;		// Min time for silence on for APD 
//	int nDXBD_MAXSLOFF;		// Max time for silence off for  APD 
//	int nDXBD_HWTYPE;		// Either a D/40 or D/41 
//	int nDXBD_CHNUM;		// Number of channels on board 
//	int nDXBD_SYSCFG;		// System configuration 
//	int nDXBD_MFMINON;		// Min time for MF detection 
//	int nDXBD_MFTONE;		// Duration of MF tone during dial 
//	int nDXBD_MFDELAY;		// Inter-digit delay during MF dialing 
//	int nDXBD_MFLKPTONE;	// Duration of LKP tone during MF dialing 
//	int nDXBD_MINSLON;		// Min time of silence on for APD 
//	int nDXBD_MINSLOFF;		// Min time for silence off for APD 
//	int nDXBD_MINTION;		// Min time for dti signal on 
//	int nDXBD_MINTIOFF;		// Min time for dti signal off 
//	int nDXBD_R_EDGE;		// Edge of ring detection 
//	int nDXBD_S_BNC;		// Silence on and off debounce time 
//	int nDXBD_MINIPD;		// Min interpulse digit time for LPD 

//typedef struct _csbdparms {
//	int nDXBD_TTDATA;		// Length of DTMF digit for dialing
//	int nDXBD_FLASHTM;		// Flash time during dialing 
//	int nDXBD_PAUSETM;		// Pause time during dialing 
//	int nDXBD_P_MK;			// Length of pulse dialing make 
//	int nDXBD_P_BK;			// Length of pulse dialing break 
//	int nDXBD_P_IDD;		// Length of pulse inter digit delay
//	int nDXBD_T_IDD;		// Length of TT inter digit delay 
//	int nDXBD_R_ON;			// Min time for ring detection
//	int nDXBD_R_OFF;		// Min time for for the end of a ring
//	int nDXBD_R_IRD;		// Max wait between rings 
//	int nDXBD_MINLCOFF;		// Min time of lc off before message
//} CSBDPARMS, *PCSBDPARMS;

