// ************************************************************************
// **   FILENAME:          DXXXLIB.CPP
// **
// **   CREATED:           4/8/96
// **   LAST MODIFIED:     8/20/99
// **
// **   VERSION:           4.0
// **   MODULE:            DXXXLIB.CPP
// **
// **   DESCRIPTION:       Dialogic Voice Library Compatability Module   
// **
// **   Copyright (c) 1998 Dialogic Corp.
// **   WRK 8/20/99 Added function definitions
//                  dx_TxIottData()
//                  dx_RxIottData()
//                  dx_TxRxIottData()
// ************************************************************************

#include <windows.h>
#include <stdlib.h>
#include <io.h>
#include <sys\stat.h>

#ifndef __CROSS_COMPAT_LIB__
#define __CROSS_COMPAT_LIB__
#endif

#include <srllib.h>
#include <dxxxlib.h>

//
// prototype for 'not implemented' functions
//
static int  dx_dflt_lasterr(void);
static long dx_long_notimp(int ddd);
static char * dx_null_notimp(int ddd);
static int dx_dflt_errno(void);

//
// typedefs & defines
//
typedef void (*func_ptr)(void);
struct func_table {
   char *fname;
   func_ptr fptr;
};

#define  ag_getctinfo_ID              0
#define  ag_getxmitslot_ID            1
#define  ag_listen_ID                 2
#define  ag_unlisten_ID               3
#define  dx_addspddig_ID              4
#define  dx_addtone_ID                5
#define  dx_addvoldig_ID              6
#define  dx_adjsv_ID                  7
#define  dx_blddt_ID                  8
#define  dx_blddtcad_ID               9
#define  dx_bldst_ID                 10
#define  dx_bldstcad_ID              11
#define  dx_bldtngen_ID              12
#define  dx_chgfreq_ID               13
#define  dx_chgdur_ID                14
#define  dx_chgrepcnt_ID             15
#define  dx_close_ID                 16
#define  dx_clrcap_ID                17
#define  dx_clrdigbuf_ID             18
#define  dx_clrsvcond_ID             19
#define  dx_clrtpt_ID                20
#define  dx_deltones_ID              21
#define  dx_dial_ID                  22
#define  dx_distone_ID               23
#define  dx_enbtone_ID               24
#define  dx_getcursv_ID              25
#define  dx_getctinfo_ID             26
#define  dx_getdig_ID                27
#define  dx_getevt_ID                28
#define  dx_getparm_ID               29
#define  dx_getsvmt_ID               30
#define  dx_getxmitslot_ID           31
#define  dx_initcallp_ID             32
#define  dx_listen_ID                33
#define  dx_open_ID                  34
#define  dx_play_ID                  35
#define  dx_playf_ID                 36
#define  dx_playtone_ID              37
#define  dx_rec_ID                   38
#define  dx_recf_ID                  39
#define  dx_route_ID                 40
#define  dx_routerxtx_ID             41
#define  dx_sendevt_ID               42
#define  dx_setdigtyp_ID             43
#define  dx_setevtmsk_ID             44
#define  dx_setgtdamp_ID             45
#define  dx_sethook_ID               46
#define  dx_setparm_ID               47
#define  dx_setrings_ID              48
#define  dx_setsvcond_ID             49
#define  dx_setsvmt_ID               50
#define  dx_setuio_ID                51
#define  dx_stopch_ID                52
#define  dx_unlisten_ID              53
#define  dx_wink_ID                  54
#define  dx_wtring_ID                55
#define  dx_fileopen_ID              56
#define  dx_fileclose_ID             57
#define  dx_fileseek_ID              58
#define  dx_fileread_ID              59
#define  dx_filewrite_ID             60
#define  dx_filesopen_ID             61
#define  dx_filelocking_ID           62
#define  dx_filechsize_ID            63
#define  dx_filecommit_ID            64
#define  dx_filedup_ID               65
#define  dx_filedup2_ID              66
#define  dx_fileumask_ID             67
#define  dx_filetell_ID              68
#define  dx_filestat_ID              69
#define  dx_filefstat_ID             70
#define  dx_filefilelength_ID        71
#define  dx_fileisatty_ID            72
#define  dx_filesetmode_ID           73
#define  dx_fileopen_osfhandle_ID    74
#define  dx_playiottdata_ID          75
#define  dx_playwav_ID               76
#define  dx_playvox_ID               77
#define  dx_reciottdata_ID           78
#define  dx_recwav_ID                79
#define  dx_recvox_ID                80
#define  dx_getr2mf_ID               81
#define  ATDX_BDNAMEP_ID             82
#define  ATDX_CHNAMES_ID             83
#define  ATDX_BDTYPE_ID              84
#define  ATDX_BUFDIGS_ID             85
#define  ATDX_CHNUM_ID               86
#define  ATDX_DBMASK_ID              87
#define  ATDX_DEVTYPE_ID             88
#define  ATDX_EVTCNT_ID              89
#define  ATDX_FWVER_ID               90
#define  ATDX_HOOKST_ID              91
#define  ATDX_LINEST_ID              92
#define  ATDX_NUMCHAN_ID             93
#define  ATDX_PHYADDR_ID             94
#define  ATDX_PRODUCT_ID             95
#define  ATDX_RINGCNT_ID             96
#define  ATDX_DIGBUFMODE_ID          97
#define  ATDX_STATE_ID               98
#define  ATDX_TERMMSK_ID             99
#define  ATDX_TONEID_ID             100
#define  ATDX_TRCOUNT_ID            101
#define  ATDX_ANSRSIZ_ID            102
#define  ATDX_CONNTYPE_ID           103
#define  ATDX_CPERROR_ID            104
#define  ATDX_CPTERM_ID             105
#define  ATDX_FRQDUR_ID             106
#define  ATDX_FRQDUR2_ID            107
#define  ATDX_FRQDUR3_ID            108
#define  ATDX_FRQHZ_ID              109
#define  ATDX_FRQHZ2_ID             110
#define  ATDX_FRQHZ3_ID             111
#define  ATDX_FRQOUT_ID             112
#define  ATDX_LONGLOW_ID            113
#define  ATDX_SHORTLOW_ID           114
#define  ATDX_SIZEHI_ID             115
#define  ATDX_DTNFAIL_ID            116
#define  ATDX_CRTNID_ID             117
#define  dx_set_lasterr_ID          118
#define  dx_fileerrno_ID            119
#define  dx_gtcallid_ID             120
#define  dx_gtextcallid_ID          121
#define  dx_wtcallid_ID             122
#define  dx_TSFStatus_ID            123
#define  dx_gtsernum_ID             124
#define  dx_mreciottdata_ID         125
#define  dx_setuio_direct_ID        126
#define  dx_getuio_ID               127
#define  dx_setiostatus_ID          128
#define  ATDX_XFERBUFSIZE_ID        129
#define  dx_setdevuio_ID            130
#define  dx_playtoneEx_ID           131
#define  dx_get_tngencad_ID         132
#define  dx_getxmitslotecr_ID       133
#define  dx_listenecr_ID            134
#define  dx_unlistenecr_ID          135
#define  dx_getfeaturelist_ID       136
#define  dx_listenecrex_ID          137
#define  dx_TxIottData_ID           138
#define  dx_RxIottData_ID           139
#define  dx_TxRxIottData_ID         140

typedef int (*ptr_ag_getctinfo)( int chDev, CT_DEVINFO *ct_devinfop);
typedef int (*ptr_ag_getxmitslot)( int chDev, SC_TSINFO *sc_tsinfop);
typedef int (*ptr_ag_listen)( int chDev, SC_TSINFO *sc_tsinfop );
typedef int (*ptr_ag_unlisten)( int chDev );
typedef int (*ptr_dx_addspddig)( int chdev, char digit, short adjval );
typedef int (*ptr_dx_addtone)( int chdev, unsigned char digit, unsigned char digtype );
typedef int (*ptr_dx_addvoldig)( int chdev, char digit, short adjval );
typedef int (*ptr_dx_adjsv)( int chdev, unsigned short tabletype, unsigned short action, unsigned short adjsize );
typedef int (*ptr_dx_blddt)( unsigned int id,   unsigned freq1, unsigned int fq1dev, unsigned int freq2, unsigned int fq2dev,unsigned int mode );
typedef int (*ptr_dx_blddtcad)( unsigned int ToneID, unsigned int freq1,   unsigned int fq1dev, unsigned int freq2,   unsigned int fq2dev, unsigned int OnTime,  unsigned int OnTimeDev, unsigned int OffTime, unsigned int OffTimeDev, unsigned int repcnt );
typedef int (*ptr_dx_bldst)( unsigned int ToneID, unsigned int freq, unsigned int fqdev, unsigned int mode );
typedef int (*ptr_dx_bldstcad)( unsigned int ToneID, unsigned int freq, unsigned int fqdev, unsigned int OnTime,  unsigned int OnTimeDev, unsigned int OffTime, unsigned int OffTimeDev, unsigned int repcnt );
typedef void (*ptr_dx_bldtngen)( TN_GEN *tngenp, unsigned short freq1, unsigned short freq2,short amplitude1,    short amplitude2, short duration );
typedef int (*ptr_dx_chgfreq)( int tonetype, int fq1, int dv1, int fq2, int dv2 );
typedef int (*ptr_dx_chgdur)( int typetype, int on, int ondv, int off, int offdv );
typedef int (*ptr_dx_chgrepcnt)( int tonetype, int repcount );
typedef int (*ptr_dx_close)( int dev );
typedef void (*ptr_dx_clrcap)( DX_CAP *capp );
typedef int (*ptr_dx_clrdigbuf)( int chdev );
typedef int (*ptr_dx_clrsvcond)( int chdev );
typedef int (*ptr_dx_clrtpt)( DV_TPT *tptp, int size );
typedef int (*ptr_dx_deltones)( int chdev );
typedef int (*ptr_dx_dial)( int chdev, const char *dialstrp, const DX_CAP *capp, unsigned short mode );
typedef int (*ptr_dx_distone)( int chdev, int toneID, int evtMask );
typedef int (*ptr_dx_enbtone)( int chdev, int ToneID, int evtMask );
typedef int (*ptr_dx_getcursv)( int chdev, int *curvolp, int *curspeedp );
typedef int (*ptr_dx_getctinfo)( int chDev, CT_DEVINFO *ct_devinfop);
typedef int (*ptr_dx_getdig)( int chdev, const DV_TPT *tptp, DV_DIGIT *digitp, unsigned short mode );
typedef int (*ptr_dx_getevt)( int chdev, DX_EBLK *eblkp, int timeout );
typedef int (*ptr_dx_getparm)( int dev, unsigned long parm, void * valuep );
typedef int (*ptr_dx_getsvmt)( int ChDev, unsigned short tableType, DX_SVMT *svmtp );
typedef int (*ptr_dx_getxmitslot)( int chDev, SC_TSINFO *sc_tsinfop);
typedef int (*ptr_dx_initcallp)( int chdev );
typedef int (*ptr_dx_listen)( int chDev, SC_TSINFO *sc_tsinfop );
typedef int (*ptr_dx_open)( const char *namep, int oflags );
typedef int (*ptr_dx_play)( int ChDev, DX_IOTT *iottp, const DV_TPT *tptp, unsigned short mode );
typedef int (*ptr_dx_playf)(int ChDev, const char *fNamep, const DV_TPT *tptp, unsigned short mode);
typedef int (*ptr_dx_playtone)( int ChDev, const TN_GEN *tngenp, const DV_TPT *tptp, int mode );
typedef int (*ptr_dx_rec)(int ChDev, DX_IOTT *iottp, const DV_TPT *tptp, unsigned short mode);
typedef int (*ptr_dx_recf)( int ChDev, const char *fNamep, const DV_TPT *tptp, unsigned short mode);
typedef int (*ptr_dx_route)( int BdDev, int Chan, int TimeSlot );
typedef int (*ptr_dx_routerxtx)( int BdDev, int Chan, int RxTimeSlot, int TxTimeSlot );
typedef int (*ptr_dx_sendevt)( int devd, unsigned long evttype, void *evtdatap, short evtlen, unsigned short flags);
typedef int (*ptr_dx_setdigtyp)( int ChDev, unsigned short DigitMask );
typedef int (*ptr_dx_setevtmsk)( int ChDev, unsigned int mask );
typedef void (*ptr_dx_setgtdamp)( short Min1, short Max1, short Min2, short Max2 );
typedef int (*ptr_dx_sethook)( int ChDev, int HookState, unsigned short mode );
typedef int (*ptr_dx_setparm)( int Dev, unsigned long parm, const void * valuep );
typedef int (*ptr_dx_setrings)( int devd, unsigned int nrings );
typedef int (*ptr_dx_setsvcond)( int ChDev, unsigned short numBlks, const DX_SVCB *svcbp );
typedef int (*ptr_dx_setsvmt)( int ChDev, unsigned short TableType, const DX_SVMT *svmtp, unsigned short flag  );
typedef int (*ptr_dx_setuio)( DX_UIO uio);
typedef int (*ptr_dx_stopch)( int ChDev, unsigned short mode );
typedef int (*ptr_dx_unlisten)( int chDev );
typedef int (*ptr_dx_wink)( int ChDev, unsigned short mode );
typedef int (*ptr_dx_wtring)( int ChDev, int numRings, int HookState, int timeout );
typedef int (*ptr_dx_fileopen )( const char * filep, int flags, int pmode);
typedef int (*ptr_dx_fileclose )( int handle );
typedef long (*ptr_dx_fileseek )( int handle, long offset, int origin );
typedef int (*ptr_dx_fileread )( int handle, void * buffer, unsigned int count );
typedef int (*ptr_dx_filewrite )( int handle, void * buffer, unsigned int count );
typedef int (*ptr_dx_filesopen )( const char * filep, int oflag, int shflag, int pmode);
typedef int (*ptr_dx_filelocking )( int handle, int mode, long bytes );
typedef int (*ptr_dx_filechsize )( int handle, long size );
typedef int (*ptr_dx_filecommit )( int handle );
typedef int (*ptr_dx_filedup )( int handle );
typedef int (*ptr_dx_filedup2 )( int handle1, int handle2 );
typedef int (*ptr_dx_fileumask )( int pmode );
typedef long (*ptr_dx_filetell )( int handle );
typedef int (*ptr_dx_filestat )( const char * path, struct _stat * buffer );
typedef int (*ptr_dx_filefstat )( int handle, struct _stat * buffer );
typedef long (*ptr_dx_filefilelength)( int handle );
typedef int (*ptr_dx_fileisatty)( int handle );
typedef int (*ptr_dx_filesetmode)( int handle, int mode );
typedef int (*ptr_dx_fileopen_osfhandle)( long osfhandle, int flags );
typedef int (*ptr_dx_playiottdata)( int ChDev,DX_IOTT * iottp,const DV_TPT * tptp, const DX_XPB * xpbp,unsigned short mode);
typedef int (*ptr_dx_playwav)( int ChDev, const char * fNamep, const DV_TPT *tptp, unsigned short mode);
typedef int (*ptr_dx_playvox)( int ChDev, const char * fNamep, const DV_TPT *tptp, const DX_XPB * xpbp,unsigned short mode);
typedef int (*ptr_dx_reciottdata)( int ChDev,DX_IOTT * iottp, const DV_TPT *tptp, DX_XPB * xpbp,unsigned short mode);
typedef int (*ptr_dx_recwav)( int ChDev, const char * fNamep, const DV_TPT *tptp, DX_XPB * xpbp,unsigned short mode);
typedef int (*ptr_dx_recvox)( int ChDev, const char * fNamep, const DV_TPT *tptp, DX_XPB * xpbp,unsigned short mode);
typedef int (*ptr_dx_getr2mf)( int Chdev, const char *src1_ptr, unsigned short src1_len, const char *src2_ptr, unsigned short src2_len,char *dest_ptr, unsigned short dest_len, unsigned short mode);
typedef char * (*ptr_ATDX_BDNAMEP)(  int ddd );
typedef char ** (*ptr_ATDX_CHNAMES)( int ddd );
typedef long (*ptr_ATDX_BDTYPE)(     int ddd );
typedef long (*ptr_ATDX_BUFDIGS)(    int ddd );
typedef long (*ptr_ATDX_CHNUM)(      int ddd );
typedef long (*ptr_ATDX_DEVTYPE)(    int ddd );
typedef long (*ptr_ATDX_DBMASK)(     int ddd );
typedef long (*ptr_ATDX_EVTCNT)(     int ddd );
typedef long (*ptr_ATDX_FWVER)(      int ddd );
typedef long (*ptr_ATDX_HOOKST)(     int ddd );
typedef long (*ptr_ATDX_LINEST)(     int ddd );
typedef long (*ptr_ATDX_NUMCHAN)(    int ddd );
typedef long (*ptr_ATDX_PHYADDR)(    int ddd );
typedef long (*ptr_ATDX_PRODUCT)(    int ddd );
typedef long (*ptr_ATDX_RINGCNT)(    int ddd );
typedef long (*ptr_ATDX_DIGBUFMODE)( int ddd );
typedef long (*ptr_ATDX_STATE)(      int ddd );
typedef long (*ptr_ATDX_TERMMSK)(    int ddd );
typedef long (*ptr_ATDX_TONEID)(     int ddd );
typedef long (*ptr_ATDX_TRCOUNT)(    int ddd );
typedef long (*ptr_ATDX_ANSRSIZ)(  int ddd );
typedef long (*ptr_ATDX_CONNTYPE)( int ddd );
typedef long (*ptr_ATDX_CPERROR)(  int ddd );
typedef long (*ptr_ATDX_CPTERM)(   int ddd );
typedef long (*ptr_ATDX_FRQDUR)(   int ddd );
typedef long (*ptr_ATDX_FRQDUR2)(  int ddd );
typedef long (*ptr_ATDX_FRQDUR3)(  int ddd );
typedef long (*ptr_ATDX_FRQHZ)(    int ddd );
typedef long (*ptr_ATDX_FRQHZ2)(   int ddd );
typedef long (*ptr_ATDX_FRQHZ3)(   int ddd );
typedef long (*ptr_ATDX_FRQOUT)(   int ddd );
typedef long (*ptr_ATDX_LONGLOW)(  int ddd );
typedef long (*ptr_ATDX_SHORTLOW)( int ddd );
typedef long (*ptr_ATDX_SIZEHI)(   int ddd );
typedef long (*ptr_ATDX_DTNFAIL)( int ddd );
typedef long (*ptr_ATDX_CRTNID)( int ddd );
typedef int  (*ptr_dx_set_lasterr)(int ddd, long error);
typedef int (*ptr_dx_fileerrno)( void );
typedef int (*ptr_dx_gtcallid)( int Chdev, unsigned char *bufp);
typedef int (*ptr_dx_gtextcallid)( int Chdev, int infotype, unsigned char *bufp);
typedef int (*ptr_dx_wtcallid)( int Chdev, int nrings, int timeout,unsigned char *bufp);
typedef int (*ptr_dx_TSFStatus)(void);
typedef int (*ptr_dx_gtsernum) (int devd, int subfcn, void *buffp);
typedef int (*ptr_dx_mreciottdata)( int ChDev, DX_IOTT *iottp, const DV_TPT *tptp, DX_XPB *xpbp, unsigned short mode, SC_TSINFO *sc_tsinfop);
typedef int (*ptr_dx_setuio_direct) (DX_UIO_DIRECT *uio_directp);
typedef int (*ptr_dx_getuio) (DX_UIO *appuiop);
typedef int (*ptr_dx_setiostatus) (int ddd, int status);
typedef long (*ptr_ATDX_XFERBUFSIZE) (int ddd);
typedef int (*ptr_dx_setdevuio) (int ddd, DX_UIO *devuiop, DX_UIO **retuiop);
typedef int (*ptr_dx_playtoneEx)( int ddd, const TN_GENCAD *tngencadp, const DV_TPT *tptp, int mode);
typedef TN_GENCAD * (*ptr_dx_get_tngencad)( unsigned int toneid );
typedef int (*ptr_dx_getxmitslotecr)( int chDev, SC_TSINFO *sc_tsinfop);
typedef int (*ptr_dx_listenecr)( int chDev, SC_TSINFO *sc_tsinfop );
typedef int (*ptr_dx_listenecrex)( int chDev, SC_TSINFO *sc_tsinfop, void *ecrctp );
typedef int (*ptr_dx_unlistenecr)( int chDev );
typedef int (*ptr_dx_getfeaturelist) (int chDev, FEATURE_TABLE *feature_tablep );
typedef int (*ptr_dx_TxIottData)   (int chDev, DX_IOTT *iottp, const DV_TPT *lpTerm, int wType, LPVOID lpParams, unsigned short mode );
typedef int (*ptr_dx_RxIottData)   (int chDev, DX_IOTT *iottp, const DV_TPT *lpTerm, int wType, LPVOID lpParams, unsigned short mode );
typedef int (*ptr_dx_TxRxIottData) (int chDev, DX_IOTT *Txiottp, const DV_TPT *lpTxTerm, DX_IOTT *Rxiottp, const DV_TPT *lpRxTerm, int wType, LPVOID lpParams, unsigned short mode );

//
// Global variables
//
static struct func_table DxxFunc[] = {
{ "ag_getctinfo"    , (func_ptr)dx_long_notimp },
{ "ag_getxmitslot"  , (func_ptr)dx_long_notimp },
{ "ag_listen"       , (func_ptr)dx_long_notimp },
{ "ag_unlisten"     , (func_ptr)dx_long_notimp },
{ "dx_addspddig"    , (func_ptr)dx_long_notimp },
{ "dx_addtone"      , (func_ptr)dx_long_notimp },
{ "dx_addvoldig"    , (func_ptr)dx_long_notimp },
{ "dx_adjsv"        , (func_ptr)dx_long_notimp },
{ "dx_blddt"        , (func_ptr)dx_long_notimp },
{ "dx_blddtcad"     , (func_ptr)dx_long_notimp },
{ "dx_bldst"        , (func_ptr)dx_long_notimp },
{ "dx_bldstcad"     , (func_ptr)dx_long_notimp },
{ "dx_bldtngen"     , (func_ptr)dx_long_notimp },
{ "dx_chgfreq"      , (func_ptr)dx_long_notimp },
{ "dx_chgdur"       , (func_ptr)dx_long_notimp },
{ "dx_chgrepcnt"    , (func_ptr)dx_long_notimp },
{ "dx_close"        , (func_ptr)dx_long_notimp },
{ "dx_clrcap"       , (func_ptr)dx_long_notimp },
{ "dx_clrdigbuf"    , (func_ptr)dx_long_notimp },
{ "dx_clrsvcond"    , (func_ptr)dx_long_notimp },
{ "dx_clrtpt"       , (func_ptr)dx_long_notimp },
{ "dx_deltones"     , (func_ptr)dx_long_notimp },
{ "dx_dial"         , (func_ptr)dx_long_notimp },
{ "dx_distone"      , (func_ptr)dx_long_notimp },
{ "dx_enbtone"      , (func_ptr)dx_long_notimp },
{ "dx_getcursv"     , (func_ptr)dx_long_notimp },
{ "dx_getctinfo"    , (func_ptr)dx_long_notimp },
{ "dx_getdig"       , (func_ptr)dx_long_notimp },
{ "dx_getevt"       , (func_ptr)dx_long_notimp },
{ "dx_getparm"      , (func_ptr)dx_long_notimp },
{ "dx_getsvmt"      , (func_ptr)dx_long_notimp },
{ "dx_getxmitslot"  , (func_ptr)dx_long_notimp },
{ "dx_initcallp"    , (func_ptr)dx_long_notimp },
{ "dx_listen"       , (func_ptr)dx_long_notimp },
{ "dx_open"         , (func_ptr)dx_long_notimp },
{ "dx_play"         , (func_ptr)dx_long_notimp },
{ "dx_playf"        , (func_ptr)dx_long_notimp },
{ "dx_playtone"     , (func_ptr)dx_long_notimp },
{ "dx_rec"          , (func_ptr)dx_long_notimp },
{ "dx_recf"         , (func_ptr)dx_long_notimp },
{ "dx_route"        , (func_ptr)dx_long_notimp },
{ "dx_routerxtx"    , (func_ptr)dx_long_notimp },
{ "dx_sendevt"      , (func_ptr)dx_long_notimp },
{ "dx_setdigtyp"    , (func_ptr)dx_long_notimp },
{ "dx_setevtmsk"    , (func_ptr)dx_long_notimp },
{ "dx_setgtdamp"    , (func_ptr)dx_long_notimp },
{ "dx_sethook"      , (func_ptr)dx_long_notimp },
{ "dx_setparm"      , (func_ptr)dx_long_notimp },
{ "dx_setrings"     , (func_ptr)dx_long_notimp },
{ "dx_setsvcond"    , (func_ptr)dx_long_notimp },
{ "dx_setsvmt"      , (func_ptr)dx_long_notimp },
{ "dx_setuio"       , (func_ptr)dx_long_notimp },
{ "dx_stopch"       , (func_ptr)dx_long_notimp },
{ "dx_unlisten"     , (func_ptr)dx_long_notimp },
{ "dx_wink"         , (func_ptr)dx_long_notimp },
{ "dx_wtring"       , (func_ptr)dx_long_notimp },
#ifndef __BORLANDC__
{ "dx_fileopen"     , (func_ptr)_open },
{ "dx_fileclose"    , (func_ptr)_close },
{ "dx_fileseek"     , (func_ptr)_lseek},
{ "dx_fileread"     , (func_ptr)_read },
{ "dx_filewrite"    , (func_ptr)_write },
{ "dx_filesopen "   , (func_ptr)_sopen },
{ "dx_filelocking"  , (func_ptr)_locking },
{ "dx_filechsize"   , (func_ptr)_chsize },
{ "dx_filecommit"   , (func_ptr)_commit },
{ "dx_filedup"      , (func_ptr)_dup },
{ "dx_filedup2"     , (func_ptr)_dup2 },
{ "dx_fileumask"    , (func_ptr)_umask },
{ "dx_filetell"     , (func_ptr)_tell },
{ "dx_filestat"     , (func_ptr)_stat },
{ "dx_filefstat"    , (func_ptr)_fstat },
{ "dx_filefilelength", (func_ptr)_filelength },
{ "dx_fileisatty"   , (func_ptr)_isatty },
{ "dx_filesetmode"  , (func_ptr)_setmode },
{ "dx_fileopen_osfhandle" , (func_ptr)_open_osfhandle },
#else
{ "dx_fileopen"     , (func_ptr)open },
{ "dx_fileclose"    , (func_ptr)close },
{ "dx_fileseek"     , (func_ptr)lseek},
{ "dx_fileread"     , (func_ptr)read },
{ "dx_filewrite"    , (func_ptr)write },
{ "dx_filesopen "   , (func_ptr)sopen },
{ "dx_filelocking"  , (func_ptr)locking },
{ "dx_filechsize"   , (func_ptr)chsize },
{ "dx_filecommit"   , (func_ptr)dx_long_notimp},
{ "dx_filedup"      , (func_ptr)dup },
{ "dx_filedup2"     , (func_ptr)dup2 },
{ "dx_fileumask"    , (func_ptr)umask },
{ "dx_filetell"     , (func_ptr)tell },
{ "dx_filestat"     , (func_ptr)stat },
{ "dx_filefstat"    , (func_ptr)fstat },
{ "dx_filefilelength", (func_ptr)filelength },
{ "dx_fileisatty"   , (func_ptr)isatty },
{ "dx_filesetmode"  , (func_ptr)setmode },
{ "dx_fileopen_osfhandle" , (func_ptr)dx_long_notimp },
#endif
{ "dx_playiottdata" , (func_ptr)dx_long_notimp },
{ "dx_playwav"      , (func_ptr)dx_long_notimp },
{ "dx_playvox"      , (func_ptr)dx_long_notimp },
{ "dx_reciottdata"  , (func_ptr)dx_long_notimp },
{ "dx_recwav"       , (func_ptr)dx_long_notimp },
{ "dx_recvox"       , (func_ptr)dx_long_notimp },
{ "dx_getr2mf"      , (func_ptr)dx_long_notimp },
{ "ATDX_BDNAMEP"    , (func_ptr)dx_null_notimp },
{ "ATDX_CHNAMES"    , (func_ptr)dx_null_notimp },
{ "ATDX_BDTYPE"     , (func_ptr)dx_long_notimp },
{ "ATDX_BUFDIGS"    , (func_ptr)dx_long_notimp },
{ "ATDX_CHNUM"      , (func_ptr)dx_long_notimp },
{ "ATDX_DBMASK"     , (func_ptr)dx_long_notimp },
{ "ATDX_DEVTYPE"    , (func_ptr)dx_long_notimp },
{ "ATDX_EVTCNT"     , (func_ptr)dx_long_notimp },
{ "ATDX_FWVER"      , (func_ptr)dx_long_notimp },
{ "ATDX_HOOKST"     , (func_ptr)dx_long_notimp },
{ "ATDX_LINEST"     , (func_ptr)dx_long_notimp },
{ "ATDX_NUMCHAN"    , (func_ptr)dx_long_notimp },
{ "ATDX_PHYADDR"    , (func_ptr)dx_long_notimp },
{ "ATDX_PRODUCT"    , (func_ptr)dx_long_notimp },
{ "ATDX_RINGCNT"    , (func_ptr)dx_long_notimp },
{ "ATDX_DIGBUFMODE" , (func_ptr)dx_long_notimp },
{ "ATDX_STATE"      , (func_ptr)dx_long_notimp },
{ "ATDX_TERMMSK"    , (func_ptr)dx_long_notimp },
{ "ATDX_TONEID"     , (func_ptr)dx_long_notimp },
{ "ATDX_TRCOUNT"    , (func_ptr)dx_long_notimp },
{ "ATDX_ANSRSIZ"    , (func_ptr)dx_long_notimp },
{ "ATDX_CONNTYPE"   , (func_ptr)dx_long_notimp },
{ "ATDX_CPERROR"    , (func_ptr)dx_long_notimp },
{ "ATDX_CPTERM"     , (func_ptr)dx_long_notimp },
{ "ATDX_FRQDUR"     , (func_ptr)dx_long_notimp },
{ "ATDX_FRQDUR2"    , (func_ptr)dx_long_notimp },
{ "ATDX_FRQDUR3"    , (func_ptr)dx_long_notimp },
{ "ATDX_FRQHZ"      , (func_ptr)dx_long_notimp },
{ "ATDX_FRQHZ2"     , (func_ptr)dx_long_notimp },
{ "ATDX_FRQHZ3"     , (func_ptr)dx_long_notimp },
{ "ATDX_FRQOUT"     , (func_ptr)dx_long_notimp },
{ "ATDX_LONGLOW"    , (func_ptr)dx_long_notimp },
{ "ATDX_SHORTLOW"   , (func_ptr)dx_long_notimp },
{ "ATDX_SIZEHI"     , (func_ptr)dx_long_notimp },
{ "ATDX_DTNFAIL"    , (func_ptr)dx_long_notimp },
{ "ATDX_CRTNID"     , (func_ptr)dx_long_notimp },
{ "dx_set_lasterr"  , (func_ptr)dx_dflt_lasterr },
{ "dx_fileerrno"    , (func_ptr)dx_dflt_errno  },
{ "dx_gtcallid"     , (func_ptr)dx_long_notimp },
{ "dx_gtextcallid"  , (func_ptr)dx_long_notimp },
{ "dx_wtcallid"     , (func_ptr)dx_long_notimp },
{ "dx_TSFStatus"    , (func_ptr)dx_long_notimp },
{ "dx_gtsernum"     , (func_ptr)dx_long_notimp },
{ "dx_mreciottdata" , (func_ptr)dx_long_notimp },
{ "dx_setuio_direct", (func_ptr)dx_long_notimp },
{ "dx_getuio"       , (func_ptr)dx_long_notimp },
{ "dx_setiostatus"  , (func_ptr)dx_long_notimp },
{ "ATDX_XFERBUFSIZE", (func_ptr)dx_long_notimp },
{ "dx_setdevuio"    , (func_ptr)dx_long_notimp },
{ "dx_playtoneEx"   , (func_ptr)dx_long_notimp },
{ "dx_get_tngencad" , (func_ptr)dx_long_notimp },
{ "dx_getxmitslotecr" , (func_ptr)dx_long_notimp },
{ "dx_listenecr"    , (func_ptr)dx_long_notimp },
{ "dx_unlistenecr"  , (func_ptr)dx_long_notimp },
{ "dx_getfeaturelist" , (func_ptr)dx_long_notimp},
{ "dx_listenecrex"    , (func_ptr)dx_long_notimp },
{ "dx_TxIottData"   , (func_ptr)dx_long_notimp },
{ "dx_RxIottData"   , (func_ptr)dx_long_notimp },
{ "dx_TxRxIottData" , (func_ptr)dx_long_notimp }
};

static char mtlibname[] = "LIBDXXMT.DLL";
static char stlibname[] = "LIBDXXX.DLL";
static char *libname;



long dx_libinit(unsigned short flag)
{
    struct func_table * dxxp = DxxFunc;
    func_ptr ProcAddress;
    static HINSTANCE LibHandle = NULL;
    DWORD filever, prodver;
    DWORD NumberofFunctions;

    //
    // check if already open
    //
    if (LibHandle != (HINSTANCE)NULL) {
       return(-1);
    }

    //
    // Determine the library to load
    //
    if ((flag & DLGC_MT) == DLGC_MT) {
       libname = mtlibname;
    } else {
       libname = mtlibname;
       dx_GetDllVersion(&filever, &prodver);
       if (filever <= 0x0004000A) {
          libname = stlibname;
       } 
    }
    NumberofFunctions = sizeof(DxxFunc)/sizeof(DxxFunc[0]);

    //
    // Try and load the VOICE library. If no library then set up
    // default entrypoints for each function.
    //
    if ((LibHandle = LoadLibrary(libname)) == (HINSTANCE)NULL) {
       return(0);
    }

    //
    // The library has been loaded. Set up each entry to a default
    // not implemented function and then overwrite the true address if
    // the function is present in the DLL.
    //
    while ( NumberofFunctions-- ) {
       ProcAddress = (func_ptr)GetProcAddress(LibHandle, dxxp->fname);
       if (ProcAddress) {
          dxxp->fptr = ProcAddress;
       }
       dxxp++;
    }

    return(0);
}

int ag_getctinfo( int chDev, CT_DEVINFO *ct_devinfop)
{
   ptr_ag_getctinfo p;

   p = (ptr_ag_getctinfo)*DxxFunc[ag_getctinfo_ID].fptr;
   return( (*p)( chDev, ct_devinfop) );
}

int ag_getxmitslot( int chDev, SC_TSINFO *sc_tsinfop)
{
   ptr_ag_getxmitslot p;

   p = (ptr_ag_getxmitslot)*DxxFunc[ag_getxmitslot_ID].fptr;
   return( (*p)( chDev, sc_tsinfop));
}

int ag_listen( int chDev, SC_TSINFO *sc_tsinfop )
{
   ptr_ag_listen p;

   p = (ptr_ag_listen)*DxxFunc[ag_listen_ID].fptr;
   return( (*p)( chDev, sc_tsinfop ));
}

int ag_unlisten( int chDev )
{
   ptr_ag_unlisten p;

   p = (ptr_ag_unlisten)*DxxFunc[ag_unlisten_ID].fptr;
   return( (*p)( chDev ));
}

int dx_addspddig( int chdev, char digit, short adjval )
{
   ptr_dx_addspddig p;

   p = (ptr_dx_addspddig)*DxxFunc[dx_addspddig_ID].fptr;
   return( (*p)( chdev, digit, adjval ));
}

int dx_addtone( int chdev, unsigned char digit, unsigned char digtype )
{
   ptr_dx_addtone p;

   p = (ptr_dx_addtone)*DxxFunc[dx_addtone_ID].fptr;
   return( (*p)( chdev, digit, digtype ));
}

int dx_addvoldig( int chdev, char digit, short adjval )
{
   ptr_dx_addvoldig p;

   p = (ptr_dx_addvoldig)*DxxFunc[dx_addvoldig_ID].fptr;
   return( (*p)( chdev, digit, adjval ));
}

int dx_adjsv( int chdev, unsigned short tabletype, unsigned short action, unsigned short adjsize )
{
   ptr_dx_adjsv p;

   p = (ptr_dx_adjsv)*DxxFunc[dx_adjsv_ID].fptr;
   return( (*p)( chdev, tabletype, action, adjsize ));
}

int dx_blddt( unsigned int id,   unsigned freq1, unsigned int fq1dev, unsigned int freq2, unsigned int fq2dev,unsigned int mode )
{
   ptr_dx_blddt p;

   p = (ptr_dx_blddt)*DxxFunc[dx_blddt_ID].fptr;
   return( (*p)( id, freq1, fq1dev, freq2, fq2dev, mode ));
}

int dx_blddtcad( unsigned int ToneID, unsigned int freq1,   unsigned int fq1dev, unsigned int freq2,   unsigned int fq2dev, unsigned int OnTime,  unsigned int OnTimeDev, unsigned int OffTime, unsigned int OffTimeDev, unsigned int repcnt )
{
   ptr_dx_blddtcad p;

   p = (ptr_dx_blddtcad)*DxxFunc[dx_blddtcad_ID].fptr;
   return( (*p)( ToneID, freq1, fq1dev, freq2, fq2dev, OnTime, OnTimeDev, OffTime, OffTimeDev, repcnt ));
}

int dx_bldst( unsigned int ToneID, unsigned int freq, unsigned int fqdev, unsigned int mode )
{
   ptr_dx_bldst p;

   p = (ptr_dx_bldst)*DxxFunc[dx_bldst_ID].fptr;
   return( (*p)( ToneID, freq, fqdev, mode ));
}

int dx_bldstcad( unsigned int ToneID, unsigned int freq, unsigned int fqdev, unsigned int OnTime,  unsigned int OnTimeDev, unsigned int OffTime, unsigned int OffTimeDev, unsigned int repcnt )
{
   ptr_dx_bldstcad p;

   p = (ptr_dx_bldstcad)*DxxFunc[dx_bldstcad_ID].fptr;
   return( (*p)( ToneID, freq, fqdev, OnTime,  OnTimeDev, OffTime, OffTimeDev, repcnt ));
}

void dx_bldtngen( TN_GEN *tngenp, unsigned short freq1, unsigned short freq2,short amplitude1,    short amplitude2, short duration )
{
   ptr_dx_bldtngen p;

   p = (ptr_dx_bldtngen)*DxxFunc[dx_bldtngen_ID].fptr;
   (*p)( tngenp, freq1, freq2, amplitude1, amplitude2, duration );
}

int dx_chgfreq( int tonetype, int fq1, int dv1, int fq2, int dv2 )
{
   ptr_dx_chgfreq p;

   p = (ptr_dx_chgfreq)*DxxFunc[dx_chgfreq_ID].fptr;
   return( (*p)( tonetype, fq1, dv1, fq2, dv2 ));
}

int dx_chgdur( int typetype, int on, int ondv, int off, int offdv )
{
   ptr_dx_chgdur p;

   p = (ptr_dx_chgdur)*DxxFunc[dx_chgdur_ID].fptr;
   return( (*p)( typetype, on, ondv, off, offdv ));
}

int dx_chgrepcnt( int tonetype, int repcount )
{
   ptr_dx_chgrepcnt p;

   p = (ptr_dx_chgrepcnt)*DxxFunc[dx_chgrepcnt_ID].fptr;
   return( (*p)( tonetype, repcount ));
}

int dx_close( int dev )
{
   ptr_dx_close p;

   p = (ptr_dx_close)*DxxFunc[dx_close_ID].fptr;
   return( (*p)( dev ));
}

void dx_clrcap( DX_CAP *capp )
{
   ptr_dx_clrcap p;

   p = (ptr_dx_clrcap)*DxxFunc[dx_clrcap_ID].fptr;
   (*p)( capp );
}

int dx_clrdigbuf( int chdev )
{
   ptr_dx_clrdigbuf p;

   p = (ptr_dx_clrdigbuf)*DxxFunc[dx_clrdigbuf_ID].fptr;
   return( (*p)( chdev ));
}

int dx_clrsvcond( int chdev )
{
   ptr_dx_clrsvcond p;

   p = (ptr_dx_clrsvcond)*DxxFunc[dx_clrsvcond_ID].fptr;
   return( (*p)( chdev ));
}

int dx_clrtpt( DV_TPT *tptp, int size )
{
   ptr_dx_clrtpt p;

   p = (ptr_dx_clrtpt)*DxxFunc[dx_clrtpt_ID].fptr;
   return( (*p)( tptp, size ));
}

int dx_deltones( int chdev )
{
   ptr_dx_deltones p;

   p = (ptr_dx_deltones)*DxxFunc[dx_deltones_ID].fptr;
   return( (*p)( chdev ));
}

int dx_dial( int chdev, const char *dialstrp, const DX_CAP *capp, unsigned short mode )
{
   ptr_dx_dial p;

   p = (ptr_dx_dial)*DxxFunc[dx_dial_ID].fptr;
   return( (*p)( chdev, dialstrp, capp, mode ));
}

int dx_distone( int chdev, int toneID, int evtMask )
{
   ptr_dx_distone p;

   p = (ptr_dx_distone)*DxxFunc[dx_distone_ID].fptr;
   return( (*p)( chdev, toneID, evtMask ));
}

int dx_enbtone( int chdev, int ToneID, int evtMask )
{
   ptr_dx_enbtone p;

   p = (ptr_dx_enbtone)*DxxFunc[dx_enbtone_ID].fptr;
   return( (*p)( chdev, ToneID, evtMask ));
}

int dx_getcursv( int chdev, int *curvolp, int *curspeedp )
{
   ptr_dx_getcursv p;

   p = (ptr_dx_getcursv)*DxxFunc[dx_getcursv_ID].fptr;
   return( (*p)( chdev, curvolp, curspeedp ));
}

int dx_getctinfo( int chDev, CT_DEVINFO *ct_devinfop)
{
   ptr_dx_getctinfo p;

   p = (ptr_dx_getctinfo)*DxxFunc[dx_getctinfo_ID].fptr;
   return( (*p)( chDev, ct_devinfop));
}

int dx_getdig( int chdev, const DV_TPT *tptp, DV_DIGIT *digitp, unsigned short mode )
{
   ptr_dx_getdig p;

   p = (ptr_dx_getdig)*DxxFunc[dx_getdig_ID].fptr;
   return( (*p)( chdev, tptp, digitp, mode ));
}

int dx_getevt( int chdev, DX_EBLK *eblkp, int timeout )
{
   ptr_dx_getevt p;

   p = (ptr_dx_getevt)*DxxFunc[dx_getevt_ID].fptr;
   return( (*p)( chdev, eblkp, timeout ));
}

int dx_getparm( int dev, unsigned long parm, void * valuep )
{
   ptr_dx_getparm p;

   p = (ptr_dx_getparm)*DxxFunc[dx_getparm_ID].fptr;
   return( (*p)( dev, parm, valuep ));
}

int dx_getsvmt( int ChDev, unsigned short tableType, DX_SVMT *svmtp )
{
   ptr_dx_getsvmt p;

   p = (ptr_dx_getsvmt)*DxxFunc[dx_getsvmt_ID].fptr;
   return( (*p)( ChDev, tableType, svmtp ));
}

int dx_getxmitslot( int chDev, SC_TSINFO *sc_tsinfop)
{
   ptr_dx_getxmitslot p;

   p = (ptr_dx_getxmitslot)*DxxFunc[dx_getxmitslot_ID].fptr;
   return( (*p)( chDev, sc_tsinfop));
}

int dx_initcallp( int chdev )
{
   ptr_dx_initcallp p;

   p = (ptr_dx_initcallp)*DxxFunc[dx_initcallp_ID].fptr;
   return( (*p)( chdev ));
}

int dx_listen( int chDev, SC_TSINFO *sc_tsinfop )
{
   ptr_dx_listen p;

   p = (ptr_dx_listen)*DxxFunc[dx_listen_ID].fptr;
   return( (*p)( chDev, sc_tsinfop ));
}

int dx_open( const char *namep, int oflags )
{
   ptr_dx_open p;

   p = (ptr_dx_open)*DxxFunc[dx_open_ID].fptr;
   return( (*p)( namep, oflags ));
}

int dx_play( int ChDev, DX_IOTT *iottp, const DV_TPT *tptp, unsigned short mode )
{
   ptr_dx_play p;

   p = (ptr_dx_play)*DxxFunc[dx_play_ID].fptr;
   return( (*p)( ChDev, iottp, tptp, mode ));
}

int dx_playf(int ChDev, const char *fNamep, const DV_TPT *tptp, unsigned short mode)
{
   ptr_dx_playf p;

   p = (ptr_dx_playf)*DxxFunc[dx_playf_ID].fptr;
   return( (*p)(ChDev, fNamep, tptp, mode));
}

int dx_playtone( int ChDev, const TN_GEN *tngenp, const DV_TPT *tptp, int mode )
{
   ptr_dx_playtone p;

   p = (ptr_dx_playtone)*DxxFunc[dx_playtone_ID].fptr;
   return( (*p)( ChDev, tngenp, tptp, mode ));
}

int dx_rec(int ChDev, DX_IOTT *iottp, const DV_TPT *tptp, unsigned short mode)
{
   ptr_dx_rec p;

   p = (ptr_dx_rec)*DxxFunc[dx_rec_ID].fptr;
   return( (*p)(ChDev, iottp, tptp, mode));
}

int dx_recf( int ChDev, const char *fNamep, const DV_TPT *tptp, unsigned short mode)
{
   ptr_dx_recf p;

   p = (ptr_dx_recf)*DxxFunc[dx_recf_ID].fptr;
   return( (*p)( ChDev, fNamep, tptp, mode));
}

int dx_route( int BdDev, int Chan, int TimeSlot )
{
   ptr_dx_route p;

   p = (ptr_dx_route)*DxxFunc[dx_route_ID].fptr;
   return( (*p)( BdDev, Chan, TimeSlot ));
}

int dx_routerxtx( int BdDev, int Chan, int RxTimeSlot, int TxTimeSlot )
{
   ptr_dx_routerxtx p;

   p = (ptr_dx_routerxtx)*DxxFunc[dx_routerxtx_ID].fptr;
   return( (*p)( BdDev, Chan, RxTimeSlot, TxTimeSlot ));
}

int dx_sendevt( int devd, unsigned long evttype, void *evtdatap, short evtlen, unsigned short flags)
{
   ptr_dx_sendevt p;

   p = (ptr_dx_sendevt)*DxxFunc[dx_sendevt_ID].fptr;
   return( (*p)( devd, evttype, evtdatap, evtlen, flags));
}

int dx_setdigtyp( int ChDev, unsigned short DigitMask )
{
   ptr_dx_setdigtyp p;

   p = (ptr_dx_setdigtyp)*DxxFunc[dx_setdigtyp_ID].fptr;
   return( (*p)( ChDev, DigitMask ));
}

int dx_setevtmsk( int ChDev, unsigned int mask )
{
   ptr_dx_setevtmsk p;

   p = (ptr_dx_setevtmsk)*DxxFunc[dx_setevtmsk_ID].fptr;
   return( (*p)( ChDev, mask ));
}

void dx_setgtdamp( short Min1, short Max1, short Min2, short Max2 )
{
   ptr_dx_setgtdamp p;

   p = (ptr_dx_setgtdamp)*DxxFunc[dx_setgtdamp_ID].fptr;
   (*p)( Min1, Max1, Min2, Max2 );
}

int dx_sethook( int ChDev, int HookState, unsigned short mode )
{
   ptr_dx_sethook p;

   p = (ptr_dx_sethook)*DxxFunc[dx_sethook_ID].fptr;
   return( (*p)( ChDev, HookState, mode ));
}

int dx_setparm( int Dev, unsigned long parm, const void * valuep )
{
   ptr_dx_setparm p;

   p = (ptr_dx_setparm)*DxxFunc[dx_setparm_ID].fptr;
   return( (*p)( Dev, parm, valuep ));
}

int dx_setrings( int devd, unsigned int nrings )
{
   ptr_dx_setrings p;

   p = (ptr_dx_setrings)*DxxFunc[dx_setrings_ID].fptr;
   return( (*p)( devd, nrings ));
}

int dx_setsvcond( int ChDev, unsigned short numBlks, const DX_SVCB *svcbp )
{
   ptr_dx_setsvcond p;

   p = (ptr_dx_setsvcond)*DxxFunc[dx_setsvcond_ID].fptr;
   return( (*p)( ChDev, numBlks, svcbp ));
}

int dx_setsvmt( int ChDev, unsigned short TableType, const DX_SVMT *svmtp, unsigned short flag  )
{
   ptr_dx_setsvmt p;

   p = (ptr_dx_setsvmt)*DxxFunc[dx_setsvmt_ID].fptr;
   return( (*p)( ChDev, TableType, svmtp, flag  ));
}

int dx_setuio( DX_UIO uio)
{
   ptr_dx_setuio p;

   p = (ptr_dx_setuio)*DxxFunc[dx_setuio_ID].fptr;
   return( (*p)( uio ));
}

int dx_stopch( int ChDev, unsigned short mode )
{
   ptr_dx_stopch p;

   p = (ptr_dx_stopch)*DxxFunc[dx_stopch_ID].fptr;
   return( (*p)( ChDev, mode ));
}

int dx_unlisten( int chDev )
{
   ptr_dx_unlisten p;

   p = (ptr_dx_unlisten)*DxxFunc[dx_unlisten_ID].fptr;
   return( (*p)( chDev ));
}

int dx_wink( int ChDev, unsigned short mode )
{
   ptr_dx_wink p;

   p = (ptr_dx_wink)*DxxFunc[dx_wink_ID].fptr;
   return( (*p)( ChDev, mode ));
}

int dx_wtring( int ChDev, int numRings, int HookState, int timeout )
{
   ptr_dx_wtring p;

   p = (ptr_dx_wtring)*DxxFunc[dx_wtring_ID].fptr;
   return( (*p)( ChDev, numRings, HookState, timeout ));
}

int dx_fileopen ( const char * filep, int flags, int pmode)
{
   ptr_dx_fileopen  p;

   p = (ptr_dx_fileopen )*DxxFunc[dx_fileopen_ID].fptr;
   return( (*p)(  filep, flags, pmode ));
}

int dx_fileclose ( int handle )
{
   ptr_dx_fileclose  p;

   p = (ptr_dx_fileclose )*DxxFunc[dx_fileclose_ID].fptr;
   return( (*p)( handle ));
}

long dx_fileseek ( int handle, long offset, int origin )
{
   ptr_dx_fileseek  p;

   p = (ptr_dx_fileseek )*DxxFunc[dx_fileseek_ID].fptr;
   return( (*p)( handle, offset, origin ));
}

int dx_fileread ( int handle, void * buffer, unsigned int count )
{
   ptr_dx_fileread  p;

   p = (ptr_dx_fileread )*DxxFunc[dx_fileread_ID].fptr;
   return( (*p)( handle, buffer, count ));
}

int dx_filewrite ( int handle, void * buffer, unsigned int count )
{
   ptr_dx_filewrite  p;

   p = (ptr_dx_filewrite )*DxxFunc[dx_filewrite_ID].fptr;
   return( (*p)( handle, buffer, count ));
}

int dx_filesopen ( const char * filep, int oflag, int shflag, int pmode)
{
   ptr_dx_filesopen  p;

   p = (ptr_dx_filesopen )*DxxFunc[dx_filesopen_ID].fptr;
   return( (*p)( filep, oflag, shflag, pmode));
}

int dx_filelocking ( int handle, int mode, long bytes )
{
   ptr_dx_filelocking  p;

   p = (ptr_dx_filelocking )*DxxFunc[dx_filelocking_ID].fptr;
   return( (*p)( handle, mode, bytes ));
}

int dx_filechsize ( int handle, long size )
{
   ptr_dx_filechsize  p;

   p = (ptr_dx_filechsize )*DxxFunc[dx_filechsize_ID].fptr;
   return( (*p)( handle, size ));
}

int dx_filecommit ( int handle )
{
   ptr_dx_filecommit  p;

   p = (ptr_dx_filecommit )*DxxFunc[dx_filecommit_ID].fptr;
   return( (*p)( handle ));
}

int dx_filedup ( int handle )
{
   ptr_dx_filedup  p;

   p = (ptr_dx_filedup )*DxxFunc[dx_filedup_ID].fptr;
   return( (*p)( handle ));
}

int dx_filedup2 ( int handle1, int handle2 )
{
   ptr_dx_filedup2  p;

   p = (ptr_dx_filedup2 )*DxxFunc[dx_filedup2_ID].fptr;
   return( (*p)( handle1, handle2 ));
}

int dx_fileumask ( int pmode )
{
   ptr_dx_fileumask  p;

   p = (ptr_dx_fileumask )*DxxFunc[dx_fileumask_ID].fptr;
   return( (*p)( pmode ));
}

long dx_filetell ( int handle )
{
   ptr_dx_filetell  p;

   p = (ptr_dx_filetell )*DxxFunc[dx_filetell_ID].fptr;
   return( (*p)( handle ));
}

int dx_filestat ( const char * path, struct _stat * buffer )
{
   ptr_dx_filestat  p;

   p = (ptr_dx_filestat )*DxxFunc[dx_filestat_ID].fptr;
   return( (*p)( path, buffer ));
}

int dx_filefstat ( int handle, struct _stat * buffer )
{
   ptr_dx_filefstat  p;

   p = (ptr_dx_filefstat )*DxxFunc[dx_filefstat_ID].fptr;
   return( (*p)( handle, buffer ));
}

long dx_filefilelength( int handle )
{
   ptr_dx_filefilelength p;

   p = (ptr_dx_filefilelength)*DxxFunc[dx_filefilelength_ID].fptr;
   return( (*p)( handle ));
}

int dx_fileisatty( int handle )
{
   ptr_dx_fileisatty p;

   p = (ptr_dx_fileisatty)*DxxFunc[dx_fileisatty_ID].fptr;
   return( (*p)( handle ));
}

int dx_filesetmode( int handle, int mode )
{
   ptr_dx_filesetmode p;

   p = (ptr_dx_filesetmode)*DxxFunc[dx_filesetmode_ID].fptr;
   return( (*p)( handle, mode ));
}

int dx_fileopen_osfhandle( long osfhandle, int flags )
{
   ptr_dx_fileopen_osfhandle p;

   p = (ptr_dx_fileopen_osfhandle)*DxxFunc[dx_fileopen_osfhandle_ID].fptr;
   return( (*p)( osfhandle, flags ));
}

int dx_playiottdata( int ChDev,DX_IOTT * iottp,const DV_TPT * tptp, const DX_XPB * xpbp,unsigned short mode)
{
   ptr_dx_playiottdata p;

   p = (ptr_dx_playiottdata)*DxxFunc[dx_playiottdata_ID].fptr;
   return( (*p)( ChDev, iottp, tptp, xpbp, mode));
}

int dx_playwav( int ChDev, const char * fNamep, const DV_TPT *tptp, unsigned short mode)
{
   ptr_dx_playwav p;

   p = (ptr_dx_playwav)*DxxFunc[dx_playwav_ID].fptr;
   return( (*p)( ChDev, fNamep, tptp, mode));
}

int dx_playvox( int ChDev, const char * fNamep, const DV_TPT *tptp, const DX_XPB * xpbp,unsigned short mode)
{
   ptr_dx_playvox p;

   p = (ptr_dx_playvox)*DxxFunc[dx_playvox_ID].fptr;
   return( (*p)( ChDev, fNamep, tptp, xpbp, mode));
}

int dx_reciottdata( int ChDev,DX_IOTT * iottp, const DV_TPT *tptp, DX_XPB * xpbp,unsigned short mode)
{
   ptr_dx_reciottdata p;

   p = (ptr_dx_reciottdata)*DxxFunc[dx_reciottdata_ID].fptr;
   return( (*p)( ChDev, iottp, tptp, xpbp, mode));
}

int dx_recwav( int ChDev, const char * fNamep, const DV_TPT *tptp, DX_XPB * xpbp,unsigned short mode)
{
   ptr_dx_recwav p;

   p = (ptr_dx_recwav)*DxxFunc[dx_recwav_ID].fptr;
   return( (*p)( ChDev, fNamep, tptp, xpbp, mode));
}

int dx_recvox( int ChDev, const char * fNamep, const DV_TPT *tptp, DX_XPB * xpbp,unsigned short mode)
{
   ptr_dx_recvox p;

   p = (ptr_dx_recvox)*DxxFunc[dx_recvox_ID].fptr;
   return( (*p)( ChDev, fNamep, tptp, xpbp, mode));
}

int dx_getr2mf( int Chdev, const char *src1_ptr, unsigned short src1_len, const char *src2_ptr, unsigned short src2_len,char *dest_ptr, unsigned short dest_len, unsigned short mode)
{
   ptr_dx_getr2mf p;

   p = (ptr_dx_getr2mf)*DxxFunc[dx_getr2mf_ID].fptr;
   return( (*p)( Chdev, src1_ptr, src1_len, src2_ptr, src2_len, dest_ptr, dest_len, mode));
}

char * ATDX_BDNAMEP(  int ddd )
{
   ptr_ATDX_BDNAMEP p;

   p = (ptr_ATDX_BDNAMEP)*DxxFunc[ATDX_BDNAMEP_ID].fptr;
   return((*p)( ddd ));
}

char ** ATDX_CHNAMES( int ddd )
{
   ptr_ATDX_CHNAMES p;

   p = (ptr_ATDX_CHNAMES)*DxxFunc[ATDX_CHNAMES_ID].fptr;
   return((*p)( ddd ));
}

long ATDX_BDTYPE(     int ddd )
{
   ptr_ATDX_BDTYPE p;

   p = (ptr_ATDX_BDTYPE)*DxxFunc[ATDX_BDTYPE_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_BUFDIGS(    int ddd )
{
   ptr_ATDX_BUFDIGS p;

   p = (ptr_ATDX_BUFDIGS)*DxxFunc[ATDX_BUFDIGS_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_CHNUM(      int ddd )
{
   ptr_ATDX_CHNUM p;

   p = (ptr_ATDX_CHNUM)*DxxFunc[ATDX_CHNUM_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_DEVTYPE(    int ddd )
{
   ptr_ATDX_DEVTYPE p;

   p = (ptr_ATDX_DEVTYPE)*DxxFunc[ATDX_DEVTYPE_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_DBMASK(     int ddd )
{
   ptr_ATDX_DBMASK p;

   p = (ptr_ATDX_DBMASK)*DxxFunc[ATDX_DBMASK_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_EVTCNT(     int ddd )
{
   ptr_ATDX_EVTCNT p;

   p = (ptr_ATDX_EVTCNT)*DxxFunc[ATDX_EVTCNT_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_FWVER(      int ddd )
{
   ptr_ATDX_FWVER p;

   p = (ptr_ATDX_FWVER)*DxxFunc[ATDX_FWVER_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_HOOKST(     int ddd )
{
   ptr_ATDX_HOOKST p;

   p = (ptr_ATDX_HOOKST)*DxxFunc[ATDX_HOOKST_ID].fptr;
   return( (*p)(  ddd ));
}

long ATDX_LINEST(     int ddd )
{
   ptr_ATDX_LINEST p;

   p = (ptr_ATDX_LINEST)*DxxFunc[ATDX_LINEST_ID].fptr;
   return( (*p)(  ddd ));
}

long ATDX_NUMCHAN(    int ddd )
{
   ptr_ATDX_NUMCHAN p;

   p = (ptr_ATDX_NUMCHAN)*DxxFunc[ATDX_NUMCHAN_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_PHYADDR(    int ddd )
{
   ptr_ATDX_PHYADDR p;

   p = (ptr_ATDX_PHYADDR)*DxxFunc[ATDX_PHYADDR_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_PRODUCT(    int ddd )
{
   ptr_ATDX_PRODUCT p;

   p = (ptr_ATDX_PRODUCT)*DxxFunc[ATDX_PRODUCT_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_RINGCNT(    int ddd )
{
   ptr_ATDX_RINGCNT p;

   p = (ptr_ATDX_RINGCNT)*DxxFunc[ATDX_RINGCNT_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_DIGBUFMODE( int ddd )
{
   ptr_ATDX_DIGBUFMODE p;

   p = (ptr_ATDX_DIGBUFMODE)*DxxFunc[ATDX_DIGBUFMODE_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_STATE(      int ddd )
{
   ptr_ATDX_STATE p;

   p = (ptr_ATDX_STATE)*DxxFunc[ATDX_STATE_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_TERMMSK(    int ddd )
{
   ptr_ATDX_TERMMSK p;

   p = (ptr_ATDX_TERMMSK)*DxxFunc[ATDX_TERMMSK_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_TONEID(     int ddd )
{
   ptr_ATDX_TONEID p;

   p = (ptr_ATDX_TONEID)*DxxFunc[ATDX_TONEID_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_TRCOUNT(    int ddd )
{
   ptr_ATDX_TRCOUNT p;

   p = (ptr_ATDX_TRCOUNT)*DxxFunc[ATDX_TRCOUNT_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_ANSRSIZ(  int ddd )
{
   ptr_ATDX_ANSRSIZ p;

   p = (ptr_ATDX_ANSRSIZ)*DxxFunc[ATDX_ANSRSIZ_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_CONNTYPE( int ddd )
{
   ptr_ATDX_CONNTYPE p;

   p = (ptr_ATDX_CONNTYPE)*DxxFunc[ATDX_CONNTYPE_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_CPERROR(  int ddd )
{
   ptr_ATDX_CPERROR p;

   p = (ptr_ATDX_CPERROR)*DxxFunc[ATDX_CPERROR_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_CPTERM(   int ddd )
{
   ptr_ATDX_CPTERM p;

   p = (ptr_ATDX_CPTERM)*DxxFunc[ATDX_CPTERM_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_FRQDUR(   int ddd )
{
   ptr_ATDX_FRQDUR p;

   p = (ptr_ATDX_FRQDUR)*DxxFunc[ATDX_FRQDUR_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_FRQDUR2(  int ddd )
{
   ptr_ATDX_FRQDUR2 p;

   p = (ptr_ATDX_FRQDUR2)*DxxFunc[ATDX_FRQDUR2_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_FRQDUR3(  int ddd )
{
   ptr_ATDX_FRQDUR3 p;

   p = (ptr_ATDX_FRQDUR3)*DxxFunc[ATDX_FRQDUR3_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_FRQHZ(    int ddd )
{
   ptr_ATDX_FRQHZ p;

   p = (ptr_ATDX_FRQHZ)*DxxFunc[ATDX_FRQHZ_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_FRQHZ2(   int ddd )
{
   ptr_ATDX_FRQHZ2 p;

   p = (ptr_ATDX_FRQHZ2)*DxxFunc[ATDX_FRQHZ2_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_FRQHZ3(   int ddd )
{
   ptr_ATDX_FRQHZ3 p;

   p = (ptr_ATDX_FRQHZ3)*DxxFunc[ATDX_FRQHZ3_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_FRQOUT(   int ddd )
{
   ptr_ATDX_FRQOUT p;

   p = (ptr_ATDX_FRQOUT)*DxxFunc[ATDX_FRQOUT_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_LONGLOW(  int ddd )
{
   ptr_ATDX_LONGLOW p;

   p = (ptr_ATDX_LONGLOW)*DxxFunc[ATDX_LONGLOW_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_SHORTLOW( int ddd )
{
   ptr_ATDX_SHORTLOW p;

   p = (ptr_ATDX_SHORTLOW)*DxxFunc[ATDX_SHORTLOW_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_SIZEHI(   int ddd )
{
   ptr_ATDX_SIZEHI p;

   p = (ptr_ATDX_SIZEHI)*DxxFunc[ATDX_SIZEHI_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_DTNFAIL( int ddd )
{
   ptr_ATDX_DTNFAIL p;

   p = (ptr_ATDX_DTNFAIL)*DxxFunc[ATDX_DTNFAIL_ID].fptr;
   return( (*p)( ddd ));
}

long ATDX_CRTNID( int ddd )
{
   ptr_ATDX_CRTNID p;

   p = (ptr_ATDX_CRTNID)*DxxFunc[ATDX_CRTNID_ID].fptr;
   return( (*p)( ddd ));
}

int dx_set_lasterr(int ddd, long error)
{
   ptr_dx_set_lasterr p;

   p = (ptr_dx_set_lasterr)*DxxFunc[dx_set_lasterr_ID].fptr;
   return ((*p)(ddd, error));
}

int dx_fileerrno( void )
{
   ptr_dx_fileerrno p;

   p = (ptr_dx_fileerrno)*DxxFunc[dx_fileerrno_ID].fptr;
   return( (*p)());
}

int dx_gtcallid( int Chdev, unsigned char *bufp )
{
   ptr_dx_gtcallid p;

   p = (ptr_dx_gtcallid)*DxxFunc[dx_gtcallid_ID].fptr;
   return( (*p)( Chdev,bufp) );
}

int dx_gtextcallid( int Chdev, int infotype, unsigned char *bufp)
{
   ptr_dx_gtextcallid p;

   p = (ptr_dx_gtextcallid)*DxxFunc[dx_gtextcallid_ID].fptr;
   return( (*p)( Chdev, infotype, bufp) );
}

int dx_wtcallid( int Chdev, int nrings, int timeout,unsigned char *bufp)
{
   ptr_dx_wtcallid p;

   p = (ptr_dx_wtcallid)*DxxFunc[dx_wtcallid_ID].fptr;
   return( (*p)( Chdev, nrings, timeout, bufp) );
}

int dx_TSFStatus (void)
{
  ptr_dx_TSFStatus p;

  p = (ptr_dx_TSFStatus)*DxxFunc[dx_TSFStatus_ID].fptr;
  return ((*p)());
}

int dx_gtsernum (int devd, int subfcn, void *pBuff)
{
  ptr_dx_gtsernum p;

  p = (ptr_dx_gtsernum)*DxxFunc[dx_gtsernum_ID].fptr;
  return ((*p)(devd, subfcn, pBuff));
}

int dx_mreciottdata( int ChDev, DX_IOTT *iottp, const DV_TPT *tptp, DX_XPB *xpbp, unsigned short mode, SC_TSINFO *sc_tsinfop)
{
   ptr_dx_mreciottdata p;

   p = (ptr_dx_mreciottdata)*DxxFunc[dx_mreciottdata_ID].fptr;
   return( (*p)( ChDev, iottp, tptp, xpbp, mode, sc_tsinfop));
}

int dx_setuio_direct(DX_UIO_DIRECT *uio_directp)
{
  ptr_dx_setuio_direct p;

  p = (ptr_dx_setuio_direct)*DxxFunc[dx_setuio_direct_ID].fptr;
  return ((*p)(uio_directp));
}


int dx_getuio(DX_UIO *appuiop)
{
  ptr_dx_getuio p;

  p = (ptr_dx_getuio)*DxxFunc[dx_getuio_ID].fptr;
  return ((*p)(appuiop));
}


int dx_setiostatus(int ddd, int status)
{
  ptr_dx_setiostatus p;

  p = (ptr_dx_setiostatus)*DxxFunc[dx_setiostatus_ID].fptr;
  return ((*p)(ddd, status));
}


long ATDX_XFERBUFSIZE(int ddd)
{
   ptr_ATDX_XFERBUFSIZE p;

   p = (ptr_ATDX_XFERBUFSIZE)*DxxFunc[ATDX_XFERBUFSIZE_ID].fptr;
   return( (*p)( ddd ));
}


int dx_setdevuio(int ddd, DX_UIO *devuiop, DX_UIO **retuiop)
{
  ptr_dx_setdevuio p;

  p = (ptr_dx_setdevuio)*DxxFunc[dx_setdevuio_ID].fptr;
  return ((*p)(ddd, devuiop, retuiop));
}


int dx_playtoneEx(int ddd, const TN_GENCAD *tngencadp, const DV_TPT *tptp, int mode)
{
   ptr_dx_playtoneEx p;

   p = (ptr_dx_playtoneEx)*DxxFunc[dx_playtoneEx_ID].fptr;
   return((*p)(ddd, tngencadp, tptp, mode));
}


TN_GENCAD *dx_get_tngencad( unsigned int toneid )
{
   ptr_dx_get_tngencad p;

   p = (ptr_dx_get_tngencad)*DxxFunc[dx_get_tngencad_ID].fptr;
   return((*p)(toneid));
}

int dx_getxmitslotecr( int chDev, SC_TSINFO *sc_tsinfop)
{
   ptr_dx_getxmitslotecr p;

   p = (ptr_dx_getxmitslotecr)*DxxFunc[dx_getxmitslotecr_ID].fptr;
   return( (*p)( chDev, sc_tsinfop));
}

int dx_listenecr( int chDev, SC_TSINFO *sc_tsinfop)
{
   ptr_dx_listenecr p;

   p = (ptr_dx_listenecr)*DxxFunc[dx_listenecr_ID].fptr;
   return( (*p)( chDev, sc_tsinfop));
}

int dx_listenecrex( int chDev, SC_TSINFO *sc_tsinfop, void *ecrctp )
{
   ptr_dx_listenecrex p;

   p = (ptr_dx_listenecrex)*DxxFunc[dx_listenecrex_ID].fptr;
   return( (*p)( chDev, sc_tsinfop, ecrctp ));
}

int dx_unlistenecr( int chDev )
{
   ptr_dx_unlistenecr p;

   p = (ptr_dx_unlistenecr)*DxxFunc[dx_unlistenecr_ID].fptr;
   return( (*p)( chDev ));
}

int dx_getfeaturelist( int chDev, FEATURE_TABLE *feature_tablep )
{
   ptr_dx_getfeaturelist p;

   p = (ptr_dx_getfeaturelist)*DxxFunc[dx_getfeaturelist_ID].fptr;
   return( (*p)( chDev, feature_tablep ));
}

int dx_TxIottData( int chDev, DX_IOTT *iottp, const DV_TPT *lpTerm, int wType, LPVOID lpParams, unsigned short mode )
{
   ptr_dx_TxIottData p;

   p = (ptr_dx_TxIottData)*DxxFunc[dx_TxIottData_ID].fptr;
   return( (*p)( chDev, iottp, lpTerm, wType, lpParams, mode));
}

int dx_RxIottData( int chDev, DX_IOTT *iottp, const DV_TPT *lpTerm, int wType, LPVOID lpParams, unsigned short mode )
{
   ptr_dx_RxIottData p;

   p = (ptr_dx_RxIottData)*DxxFunc[dx_RxIottData_ID].fptr;
   return( (*p)( chDev, iottp, lpTerm, wType, lpParams, mode));
}

int dx_TxRxIottData( int chDev, DX_IOTT *Txiottp, const DV_TPT *lpTxTerm, DX_IOTT *Rxiottp, const DV_TPT *lpRxTerm, int wType, LPVOID lpParams, unsigned short mode )
{
   ptr_dx_TxRxIottData p;

   p = (ptr_dx_TxRxIottData)*DxxFunc[dx_TxRxIottData_ID].fptr;
   return( (*p)( chDev, Txiottp, lpTxTerm, Rxiottp, lpRxTerm, wType, lpParams, mode));
}

int dx_dflt_lasterr( void )
{
   return 0;
}

long dx_long_notimp(int ddd)
{
   dx_set_lasterr(ddd, EDX_NOTIMP);
   return(-1);
}

char * dx_null_notimp(int ddd)
{
   dx_set_lasterr(ddd, EDX_NOTIMP);
   return((char *)NULL);
}

int dx_dflt_errno( void )
{
   return(errno);
}

long dx_GetDllVersion(LPDWORD fileverp, LPDWORD prodverp)
{
   return(sr_GetVersion(libname, fileverp,prodverp));
}

