/***************************************************************************
 *		Copyright (c) 1996 Dialogic Corp.
 *		All Rights Reserved.
 *
 *		THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Dialogic Corp.
 *		The copyright notice above does not evidence any actual or
 *		intended publication of such source code.
 ***************************************************************************/

/****************************************************************************
 * FILE:         qmisc.h
 * ORG:          Dialogic Corporation
 * ORIG-DATE:    28-Aug-96
 * LAST-MOD:     22-Jul-97
 * PURPOSE:
 *    This file contains defines relating to misc MNTI functions.
 *
 ***************************************************************************/

// 19Feb99 guptav - Version - 1.16
// - MNT_TRACE is crashing when lpPayload is NULL. Added a Check in mntCompUse while 
//   printing the Trace information.
// - PTR #1940 Fixed.
					     
#ifndef __QMISC_H__
#define __QMISC_H__


// Define flag if compiling MNTI host library.
// Undefine flag if compiling applications.
#ifndef __MNTILIB_
#define MNTAPI __declspec(dllimport)
#else
#define MNTAPI __declspec(dllexport)
#endif


#ifndef NO_BOARD_STATUS
// Include board status header file
#include "Brd_Stat.h"
#endif // NO_BOARD_STATUS


// Define Host Library Version
#define MNTI_LIB_VERSION	"1.16"

#define TRANSACTION_MASK	0x00FFFFFF

#define MNT_MAX_OFFSET     0x0F000000

#define MNT_VERSION_STRING_SIZE  8

#if defined(__BORLANDC__)
#define _getpid()   getpid()
#endif


#ifdef __cplusplus
extern "C" {
#endif

// Functional prototypes
#if 0 
MNTAPI BOOL mntCollectPerfData(HANDLE hDevice, LPVOID lpPerf);
#endif

MNTAPI BOOL WINAPI mntGetDrvVersion(LPCSTR lpVersion);
MNTAPI BOOL WINAPI mntGetLibVersion(LPCSTR lpVersion);
MNTAPI BOOL WINAPI mntSetTraceLevel(ULONG TraceLevel, LPSTR lpTraceDeviceName);
MNTAPI VOID WINAPIV mntTrace(char *pszFmt,...);
MNTAPI QTrans WINAPI mntTransGen(void);

#ifndef NO_BOARD_STATUS
MNTAPI BOOL WINAPI mntGetBoardStatus(HANDLE			hMpath,
									 LPBOARD_STATUS	lpBoardStatus,
									 LPOVERLAPPED	lpOverlapped);
#endif // NO_BOARD_STATUS

// Post On demand function
MNTAPI BOOL WINAPI mntGetPostLocationContent(HANDLE	hMpath,
											 ULONG	boardIndex,	// Physical Board Id							
											 PUCHAR	pLoc1Contents,
										     PUCHAR	pLoc2Contents );
// Send a message to perform a POST
MNTAPI BOOL WINAPI mntSendPostMessage(IN	HANDLE	      hDevice,
    									IN	LPMMB	         lpMMB,
										IN	LPOVERLAPPED	lpOverlapped);

// Reset board function...
MNTAPI BOOL WINAPI mntResetBoard(IN	HANDLE	hMpath,
								 IN	ULONG	boardIndex); // physical board Id
                                                                                     


#ifdef __cplusplus
}
#endif

#endif	// __QMISC_H__






