//
//  Copyright  1999-2002 by Ai-Logix, Inc.
//  All rights reserved.
//
//  NTi_NV.h
//      SmartTAP API data structure declaration file for structures that are the same
//      as defined in NV.h file
//
//  AI-LOGIX, INC. PROPRIETARY.
//

#ifndef _INC_NTI_NV_H
#define _INC_NTI_NV_H

#if _WIN32
#include <pshpack1.h>
#endif


//
// Call Progress Result structure
//
typedef struct _CALL_RESULT {
    ULONG   Status;                 // status value
    ULONG   CpmTerm;                // Last CPM termination
    ULONG   OffFreq;                // Percent of signal off-frequency
    ULONG   Frequency;              // Detected frequency
    ULONG   HiTime;                 // Longest high period in cadence
    ULONG   LoTimeShort;            // Shortest low period in cadence
    ULONG   LoTimeLong;             // Longest  low period in cadence
    ULONG   AnswerTime;             // Duration of answer for CONNECT
    ULONG   SubTerm;                // Termination sub type
} CALL_RESULT, *PCALL_RESULT;


//
// Conference Group status info
//
typedef struct _GROUP_STATUS {
  ULONG     Status;                 // Group status
  ULONG     TotalChannels;          // Total number of chans in group
  ULONG     TalkChannels;           // Number of talking chans in group
  ULONG     ListenChannels;         // Number of listening chans in grp
} GROUP_STATUS, *PGROUP_STATUS;



//
// Set parameters
//
typedef struct _SET_PARAMS {
    ULONG   Status;                 // status value
    ULONG   WinkDelay;              // wink delay
    ULONG   WinkTime;               // wink time
} SET_PARAMS, *PSET_PARAMS;


//
// set events
//
typedef struct _SET_EVENTS {
    ULONG   Status;                 // status value
    ULONG   EventEnable;            // event enable bits
    ULONG   Rings;                  // number of rings for evt_rings
} SET_EVENTS, *PSET_EVENTS;


//
// set moni
//
typedef struct _SET_MONI {
    ULONG   Status;                 // status value
    ULONG   MoniEnable;             // monitor event enable bits
} SET_MONI, *PSET_MONI;


//
// set termination enable bits
//
typedef struct _SET_TERM {
    ULONG   Status;                 // status value
    ULONG   TermEnable;             // termination event enable bits
} SET_TERM, *PSET_TERM;

#if _WIN32
#include <poppack.h>
#endif

#endif

// End of NTI_NV.h
