//
//  Copyright  1999-2002 by Ai-Logix, Inc.
//  All rights reserved.
//
//  NTiAPINull.h
//      SmartTAP API not supported API declaration file
//
//  AI-LOGIX, INC. PROPRIETARY.
//

#ifndef _INC_NTIAPINULL_H
#define _INC_NTIAPINULL_H


//
// Channel Functions
//      FAX Functions

// FAX capability currently not supported in NTI product
_DLLIMPEXPORT MT_RESULT
MTSendFaxA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PMTFAX_IO_CONTROL pFAXIoCtl
    );

_DLLIMPEXPORT MT_RESULT
MTSendFaxW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PMTFAX_IO_CONTROL pFAXIoCtl
    );

_DLLIMPEXPORT MT_RESULT
MTSendFaxExA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PMTFAX_IO_CONTROL pFAXIoCtl,
    LPOVERLAPPED pOverlapped
    );

_DLLIMPEXPORT MT_RESULT
MTSendFaxExW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PMTFAX_IO_CONTROL pFAXIoCtl,
    LPOVERLAPPED pOverlapped
    );

_DLLIMPEXPORT MT_RESULT
MTRecvFaxA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PMTFAX_IO_CONTROL pFAXIoCtl
    );

_DLLIMPEXPORT MT_RESULT
MTRecvFaxW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PMTFAX_IO_CONTROL pFAXIoCtl
    );

_DLLIMPEXPORT MT_RESULT
MTRecvFaxExA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PMTFAX_IO_CONTROL pFAXIoCtl,
    LPOVERLAPPED pOverlapped
    );

_DLLIMPEXPORT MT_RESULT
MTRecvFaxExW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PMTFAX_IO_CONTROL pFAXIoCtl,
    LPOVERLAPPED pOverlapped
    );

_DLLIMPEXPORT MT_RESULT
MTFaxGetParam(
    CHANNEL     nChannel,
    USHORT      paramName,
    UCHAR       *pBuf
    );

_DLLIMPEXPORT MT_RESULT
MTFaxSetParam(
    CHANNEL     nChannel,
    USHORT      paramName,
    UCHAR       *pBuf
    );

_DLLIMPEXPORT MT_RESULT
MTFaxGetChInfo(
    CHANNEL     nChannel,
    MTFAX_INFO  *ChanInfo
    );

_DLLIMPEXPORT MT_RESULT
MTFaxSetChInfo(
    CHANNEL     nChannel,
    MTFAX_INFO  *ChanInfo
    );

_DLLIMPEXPORT MT_RESULT
MTFaxGetStatus(
    CHANNEL     nChannel,
    USHORT      request,
    USHORT      *value
    );


//
// Conference Functions
//

_DLLIMPEXPORT MT_RESULT
MTEnterGroup(
    HGROUP group,
    CHANNEL nChannel,
    USHORT dir
    );

_DLLIMPEXPORT MT_RESULT
MTUnholdGroup(
    HGROUP group
    );

_DLLIMPEXPORT MT_RESULT
MTCloseGroup(
    HGROUP group
    );

_DLLIMPEXPORT MT_RESULT
MTGetGroup(
    HGROUP group,
    ULONG * pList
    );

#if 0   // Obsoleted
_DLLIMPEXPORT MT_RESULT
MTGetMuxmatrix(
    LPBYTE matrix
    );
#endif

_DLLIMPEXPORT MT_RESULT
MTHoldGroup(
    HGROUP group
    );

_DLLIMPEXPORT MT_RESULT
MTLeaveGroup(
    HGROUP group,
    CHANNEL nChannel
    );

_DLLIMPEXPORT MT_RESULT
MTOpenGroup(
    HGROUP * group
    );

_DLLIMPEXPORT MT_RESULT
MTResetGroup(
    HGROUP group
    );

_DLLIMPEXPORT MT_RESULT
MTSetGroup(
    HGROUP group,
    ULONG * pList
    );

_DLLIMPEXPORT MT_RESULT
MTStatusGroup(
    HGROUP group,
    PGROUP_STATUS pGroup_status
    );

#endif

// End of NTiAPINull.h
