//
//  Copyright  2001-2003 by Ai-Logix, Inc.
//  All rights reserved.
//
//  File: NTiDataCC.h
//      SmartTAP CallConnection API data structure declaration file
//
//  AI-LOGIX, INC. PROPRIETARY.
//


#ifndef _INC_NTIDATACC_H
#define _INC_NTIDATACC_H

#define MT_CC_INCOMING_CALL             0x00000001
#define MT_CC_OUTGOING_CALL             0x00000002


#define MT_CC_PREFERRED                 0x00000000
#define MT_CC_EXCLUSIVE                 0x00000001
typedef struct
{
    int         Pref_Excl ;
    int         InterfaceId ;
    int         TimeSlot ;
} MT_CC_CHANNEL_ID, * PMT_CC_CHANNEL_ID;

#define MT_CC_MAX_PARTY_DIGITS          32

#define MT_CC_NUMBER_UNKNOWN            0x00000000
#define MT_CC_NUMBER_INTERNATIONAL      0x00000001
#define MT_CC_NUMBER_NATIONAL           0x00000002
#define MT_CC_NUMBER_SUBSCRIBER         0x00000004
#define MT_CC_NUMBER_ABBREVIATED        0x00000006

#define MT_CC_PLAN_UNKNOWN              0x00000000
#define MT_CC_PLAN_ITU_E164             0x00000001
#define MT_CC_PLAN_ITU_X121             0x00000003
#define MT_CC_PLAN_NATIONAL             0x00000008
#define MT_CC_PLAN_PRIVATE              0x00000009

#define MT_CC_USR_NOTSCREENED           0x00000000
#define MT_CC_USR_VERIFIED_PASSED       0x00000001
#define MT_CC_USR_VERIFIED_FAILED       0x00000002
#define MT_CC_NET_PROVIDED              0x00000003

#define MT_CC_PRES_ALLOWED              0x00000000
#define MT_CC_PRES_RESTRICTED           0x00000010
#define MT_CC_NB_NOT_AVAILABLE          0x00000020

typedef struct
{
    int     TypeOfNumber ;
    int     NumberingPlan ;
    int     NumberOfDigits ;
    UCHAR   Digits[MT_CC_MAX_PARTY_DIGITS] ;
} MT_CC_PARTY_NUMBER, * PMT_CC_PARTY_NUMBER;

#define MT_CC_MAX_SUBADDR_DIGITS        20

#define MT_CC_SUBADDR_NSAP              0x00000000 // NSAP (x213)
#define MT_CC_SUBADDR_USER              0x00000002 // USER SPECIFIED

#define MT_CC_SUBADDR_EVEN              0 //number of digits is odd
#define MT_CC_SUBADDR_ODD               1 // number of digits is even

typedef struct
{
    int     NumberOfDigits ;
    int     SubAddrType ;
    int     OddEvenInd ;
    UCHAR   Digits[MT_CC_MAX_SUBADDR_DIGITS] ;
} MT_CC_PARTY_SUBADDR, * PMT_CC_PARTY_SUBADDR;


// Transfer Caps
#define MT_CC_TRANSFER_SPEECH           0x00000000
#define MT_CC_TRANSFER_UNRESTRICTED     0x00000008
#define MT_CC_TRANSFER_RESTRICTED       0x00000009
#define MT_CC_TRANSFER_3_1KHZ_AUDIO     0x00000010
#define MT_CC_TRANSFER_VIDEO            0x00000018

// Transfer Mode
#define MT_CC_MODE_CIRCUIT_64KBPS       0x00000010
#define MT_CC_MODE_CIRCUIT_384KBPS      0x00000013
#define MT_CC_MODE_CIRCUIT_1536KBPS     0x00000015
#define MT_CC_MODE_CIRCUIT_1920KBPS     0x00000017
#define MT_CC_MODE_PACKET               0x00000080

// Layer Protocol values
#define MT_CC_LAYER1_NONE               0x00000000
#define MT_CC_LAYER1_V110               0x00000001
#define MT_CC_LAYER1_G711_MU_LAW        0x00000002
#define MT_CC_LAYER1_G711_A_LAW         0x00000003
#define MT_CC_LAYER1_G721_ADPCM         0x00000004
#define MT_CC_LAYER1_G722_G725          0x00000005
#define MT_CC_LAYER1_G7XX_VIDEO         0x00000006
#define MT_CC_LAYER1_NON_CCITT          0x00000007
#define MT_CC_LAYER1_V120               0x00000008
#define MT_CC_LAYER1_X31                0x00000009

//User Rate values
#define MT_CC_USER_NONE                 0x00000000
#define MT_CC_USER_0_6KBPS              0x00000001
#define MT_CC_USER_1_2KBPS              0x00000002
#define MT_CC_USER_2_4KBPS              0x00000003
#define MT_CC_USER_3_6KBPS              0x00000004
#define MT_CC_USER_4_8KBPS              0x00000005
#define MT_CC_USER_7_2KBPS              0x00000006
#define MT_CC_USER_8KBPS                0x00000007
#define MT_CC_USER_9_6KBPS              0x00000008
#define MT_CC_USER_14_4KBPS             0x00000009
#define MT_CC_USER_16KBPS               0x0000000A
#define MT_CC_USER_19_2KBPS             0x0000000B
#define MT_CC_USER_32KBPS               0x0000000C
#define MT_CC_USER_48KBPS               0x0000000E
#define MT_CC_USER_56KBPS               0x0000000F
#define MT_CC_USER_64KBPS               0x00000010
#define MT_CC_USER_0_1345KBPS           0x00000015
#define MT_CC_USER_0_100KBPS            0x00000016
#define MT_CC_USER_0_075KBPS_1_2KBPS    0x00000017
#define MT_CC_USER_1_2KBPS_0_075KBPS    0x00000018
#define MT_CC_USER_0_050KBPS            0x00000019
#define MT_CC_USER_0_075KBPS            0x0000001A
#define MT_CC_USER_0_110KBPS            0x0000001B
#define MT_CC_USER_0_150KBPS            0x0000001C
#define MT_CC_USER_0_200KBPS            0x0000001D
#define MT_CC_USER_0_300KBPS            0x0000001E
#define MT_CC_USER_12KBPS               0x0000001F
#define MT_CC_USER_28_8KBPS             0x00000020
#define MT_CC_USER_38_4KBPS             0x00000021
#define MT_CC_USER_48_4KBPS             0x00000022
#define MT_CC_USER_56_4KBPS             0x00000023
#define MT_CC_USER_64_4KBPS             0x00000024

//SyncAsync values:
#define MT_CC_SYNC      0x00000000
#define MT_CC_ASYNC     0x00000001

//Stop Bits values
#define MT_CC_ZERO_STOP_BITS            0x00000000
#define MT_CC_ONE_STOP_BITS             0x00000001
#define MT_CC_ONE_AND_HALF_STOP_BITS    0x00000002
#define MT_CC_TWO_STOP_BITS             0x00000003

// DataBits values:
#define MT_CC_ZERO_DATA_BITS            0x00000000
#define MT_CC_FIVE_DATA_BITS            0x00000001
#define MT_CC_V_SEVEN_DATA_BITS         0x00000002
#define MT_CC_EIGHT_DATA_BITS           0x00000003

// Parity values:
#define MT_CC_PARITY_ODD                0x00000000
#define MT_CC_PARITY_EVEN               0x00000001
#define MT_CC_PARITY_NONE               0x00000002
#define MT_CC_PARITY_FORCED_ZERO        0x00000003
#define MT_CC_PARITY_FORCED_ONE         0x00000004

typedef struct
{
    int     TransferCaps;
    int     TransferMode;
    int     Layer_1;
    int     UserRate;
    int     SyncAsync;
    int     StopBits;
    int     DataBits;
    int     Parity;
} MT_CC_BEARER_CAPS, * PMT_CC_BEARER_CAPS;

#define MT_CC_U2U_USER_SPF          0   /* user-specific protocol */
#define MT_CC_U2U_OSI               1   /* OSI high layer protocol */
#define MT_CC_U2U_X244              2   /* X.244 */
#define MT_CC_U2U_SYS_MANAGEMENT    3   /* reserved for system management convergence function */
#define MT_CC_U2U_IA5               4   /* protocol discrimination : IA5 */
#define MT_CC_U2U_X208_X209         5   /* X.208 and X.209 coded user information */
#define MT_CC_U2U_V120              7   /* CCITT Recommendation V.120 rate adaption */
#define MT_CC_U2U_Q931              8   /* Q.931 user-network call control messages */


#define MT_CC_U2U_NT2               0x40   /*  NT2 */
#define MT_CC_U2U_MESSAGING         0x41   /*  messaging */
#define MT_CC_U2U_TRANSGROUP        0x44   /*  Transgroupe specific facilities (VN) */
#define MT_CC_U2U_PUBLIPHONE        0x45   /*  Publiphone specific information (VN) */
#define MT_CC_U2U_CALL_ROUTING      0x46   /*  Routing call specific information (VN) */
#define MT_CC_U2U_AUDIOTEL          0x47   /*  FRANCE TELECOM Audiotel and Free call (VN) */

#define MT_CC_MAX_U2U_SIZE 128
typedef struct
{
    int     Length ;
    int     Protocol ;
    UCHAR   Info[MT_CC_MAX_U2U_SIZE];
} MT_CC_U2U, *PMT_CC_U2U;

#define MT_CC_MAX_IDENTITY_SIZE  12
typedef struct
{
    int     Length ;
    UCHAR   Identity[MT_CC_MAX_IDENTITY_SIZE];
} MT_CC_CALL_IDENTITY, * PMT_CC_CALL_IDENTITY;

#define MT_CC_MAX_FACILITY_SIZE  128
typedef struct
{
    int     Length ;
    UCHAR   Facility[MT_CC_MAX_FACILITY_SIZE];
} MT_CC_FACILITY, * PMT_CC_FACILITY;

#define MT_CC_MAX_USERINFO_SIZE 128
typedef struct
{
    int     Length ;
    UCHAR   Info[MT_CC_MAX_USERINFO_SIZE] ;
} MT_CC_USERINFO, * PMT_CC_USERINFO ;

typedef struct
{
    int     Value ;
    int     Type ;
    int     Period ;
    int     Multiplier ;
} MT_CC_CHARGING, * PMT_CC_CHARGING ;


typedef struct
{
    ULONG               CallRef ;
    ULONG               CallSource ;
    ULONG               CallState ;
    ULONG               CallTrunk ;
    ULONG               CallDuration ;
    ULONG               Layer1Coding ;
    ULONG               Cause ;
    MT_CC_CHANNEL_ID    ChannelId ;
    MT_CC_PARTY_NUMBER  CallerNumber ;
    MT_CC_PARTY_SUBADDR CallerSubAddr ;
    MT_CC_PARTY_NUMBER  CalledNumber ;
    MT_CC_PARTY_SUBADDR CalledSubAddr ;
    MT_CC_PARTY_NUMBER  ConnectedNumber ;
    MT_CC_PARTY_SUBADDR ConnectedSubAddr ;
    MT_CC_PARTY_NUMBER  RedirectingNumber ;
    MT_CC_CALL_IDENTITY CallIdentity ;

} MT_CC_CALL_INFO, * PMT_CC_CALL_INFO;

typedef struct
{
    ULONG               CallRef ;
    ULONG               Source ;
    MT_CC_CHANNEL_ID    ChannelId ;
    ULONG               Type ;
    ULONG               MoreData ;
    MT_CC_U2U           UserInfo ;
} MT_CC_USERINFO_IND, * PMT_CC_USERINFO_IND;

//Flags values
#define MT_CC_FLAGS_CHAN_ID                     0x00000001
#define MT_CC_FLAGS_CALLED_PARTY                0x00000002
#define MT_CC_FLAGS_CALLING_PARTY               0x00000004
#define MT_CC_FLAGS_BEARER_CAPS                 0x00000008
#define MT_CC_FLAGS_CALLED_PARTY_SUB_ADDR       0x00000010
#define MT_CC_FLAGS_CALLING_PARTY_SUB_ADDR      0x00000020
#define MT_CC_FLAGS_UUI                         0x00000040
#define MT_CC_FLAGS_FACILITY                    0x00000080


typedef struct
{
    int                 ConnectionId ;
    int                 SendingComplete ;
    int                 Flags ;
    MT_CC_CHANNEL_ID    ChannelId;
    MT_CC_BEARER_CAPS   BearerCaps;
    MT_CC_PARTY_NUMBER  CalledPartyAddr;
    MT_CC_PARTY_SUBADDR CalledPartySubAddr;
    int                 PresScrnInds ;
    MT_CC_PARTY_NUMBER  CallingPartyAddr;
    MT_CC_PARTY_SUBADDR CallingPartySubAddr;
    MT_CC_U2U           UserInfo ;
    MT_CC_FACILITY      Facility ;
} MT_CC_CONNECT_REQ, * PMT_CC_CONNECT_REQ ;

typedef struct
{
    int                 CallRef ;
    int                 SendingComplete ;
    int                 Flags ;
    MT_CC_CHANNEL_ID    ChannelId;
    MT_CC_BEARER_CAPS   BearerCaps;
    MT_CC_PARTY_NUMBER  CalledPartyAddr;
    MT_CC_PARTY_SUBADDR CalledPartySubAddr;
    MT_CC_PARTY_NUMBER  CallingPartyAddr;
    MT_CC_PARTY_SUBADDR CallingPartySubAddr;
    MT_CC_U2U           UserInfo ;
    MT_CC_FACILITY      Facility ;
} MT_CC_CONNECT_IND, * PMT_CC_CONNECT_IND;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 Flags ;
    MT_CC_CHANNEL_ID    ChannelId;
    MT_CC_U2U           UserInfo ;
    MT_CC_FACILITY      Facility ;
} MT_CC_CONNECT_RESP, * PMT_CC_CONNECT_RESP;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 Flags ;
    MT_CC_CHANNEL_ID    ChannelId;
} MT_CC_CONNECT_CONF, * PMT_CC_CONNECT_CONF;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 Flags ;
    MT_CC_PARTY_NUMBER  CalledPartyAddr;
} MT_CC_INFO_IND, * PMT_CC_INFO_IND;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 Flags ;
    MT_CC_CHANNEL_ID    ChannelId;
} MT_CC_PROGRESS_IND, * PMT_CC_PROGRESS_IND;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
} MT_CC_ALERT_IND, * PMT_CC_ALERT_IND;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 Cause ;
    MT_CC_U2U           UserInfo ;
    MT_CC_FACILITY      Facility ;
} MT_CC_DISC_REQ, * PMT_CC_DISC_REQ;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 Cause ;
} MT_CC_DISC_CONF, * PMT_CC_DISC_CONF;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 Cause ;
    MT_CC_U2U           UserInfo ;
    MT_CC_FACILITY      Facility ;
    MT_CC_CHARGING      ChargingInfo;
} MT_CC_DISC_IND, * PMT_CC_DISC_IND;

/*---------------------------------------------------------------------------
 * Voice supplementary services management.
 *--------------------------------------------------------------------------*/

typedef struct
{
    unsigned char   button_type;    /* Unknown, call appear or feature */
    unsigned char   module_nb;      /* 0-7, call appear buttons are assigned to module 0 */
    unsigned char   button_nb;      /* 1-254, 0 and 255 are reserved */
    unsigned char   call_appear;    /* selected call appearence */
    unsigned char   switchhook;     /* switchhook indication */
    unsigned char   conn_id;        /* CONFERENCE : Conn_id of the active call */
    unsigned char   res06[ 2 ] ;    /* reserved bytes to maintain DWORK alignment */
}MT_CC_VOICE_SUPSRV, * PMT_CC_VOICE_SUPSRV;

/*-----------------------------------------------
 *  Facility codes (MT_CC_FACILITY_REQ/IND/CONF)
 *-----------------------------------------------*/

#define MT_CC_FAC_CALL_FORWARDING           21  /* premise transfer */
#define MT_CC_FAC_CALL_DEFLECTION           22  /* terminal transfer */
#define MT_CC_FAC_CHARGING                  23  /* charging */
#define MT_CC_FAC_CHARGING_TOTAL            24  /* charging total cost */
#define MT_CC_FAC_HOLD                      25  /* call hold */
#define MT_CC_FAC_RETRIEVE                  26  /* call retrieve */
#define MT_CC_FAC_ALTERNATE                 27  /* "toggle" between active and held call */
#define MT_CC_FAC_TRF                       28  /* transfer */
#define MT_CC_FAC_CONFERENCE                29  /* conferencing */
#define MT_CC_FAC_MALICIOUS_CALL_ID         32  /* malicious call identification */

#define MT_CC_FAC_RECALL                    50  /* Recall facility (ETSI) */

#define MT_CC_FAC_TRANSPARENT               100 /* transparent facility for CC&NS */

#define MT_CC_FAC_CALL_APPEAR               200 /* Call appearence request */
#define MT_CC_FAC_FEATURE_ACT               201 /* Feature activation request */
#define MT_CC_FAC_DROP                      202 /* Drop call */
#define MT_CC_FAC_FEATURE_IND               203 /* Feature indication (NT->TE only) */
#define MT_CC_FAC_VOICE_MAIL                204 /* Voice-Mail feature (NI2) */


/*------------------------------------------------
 *  Action codes (MT_CC_FACILITY_REQ/IND/RESP/CONF)
 *------------------------------------------------*/

    /* MT_CC_FACILITY_RQ (TE side),
     * MT_CC_FACILITY_IN (NT side),
     */
#define MT_CC_ACTION_ACTIVATE               'A' /* activate or register action */
#define MT_CC_ACTION_CLEAR                  'C' /* deactivate or clear action */
#define MT_CC_ACTION_ENQUIRY                'E' /* enquiry action */

#define MT_CC_ACTION_ACK                    'a' /* acknowledgement */
#define MT_CC_ACTION_REJ                    'r' /* reject */

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 AccessId ;
    int                 Action ;
    int                 Code ;
    int                 Flags ;
    MT_CC_CHANNEL_ID    ChannelId;
    MT_CC_PARTY_NUMBER  CalledAddr;
    MT_CC_PARTY_NUMBER  CallingAddr;
    MT_CC_VOICE_SUPSRV  Voice ;
    MT_CC_FACILITY      Facility ;

} MT_CC_FACILITY_REQ, * PMT_CC_FACILITY_REQ;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 AccessId ;
    int                 Action ;
    int                 Code ;
    int                 NetCause ;
    int                 Flags ;
    MT_CC_CHANNEL_ID    ChannelId;
    MT_CC_PARTY_NUMBER  CalledAddr;
    MT_CC_PARTY_NUMBER  CallingAddr;
    MT_CC_VOICE_SUPSRV  Voice ;
    MT_CC_FACILITY      Facility ;

} MT_CC_FACILITY_CONF, * PMT_CC_FACILITY_CONF;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 AccessId ;
    int                 Action ;
    int                 Code ;
    int                 Flags ;
    MT_CC_CHANNEL_ID    ChannelId;
    MT_CC_PARTY_NUMBER  CalledAddr;
    MT_CC_PARTY_NUMBER  CallingAddr;
    MT_CC_VOICE_SUPSRV  Voice ;
    MT_CC_FACILITY      Facility ;

} MT_CC_FACILITY_IND, * PMT_CC_FACILITY_IND;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    MT_CC_CALL_IDENTITY CallIdentity ;

} MT_CC_SUSPEND_REQ, * PMT_CC_SUSPEND_REQ;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 RetCode ;
    int                 NetCause ;
    MT_CC_CALL_IDENTITY CallIdentity ;

} MT_CC_SUSPEND_CONF, * PMT_CC_SUSPEND_CONF;

typedef struct
{
    int                 ConnectionId ;
    MT_CC_CALL_IDENTITY CallIdentity ;

} MT_CC_RESUME_REQ, * PMT_CC_RESUME_REQ;

typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    int                 RetCode ;
    int                 NetCause ;
    MT_CC_CHANNEL_ID    ChannelId;
    MT_CC_CALL_IDENTITY CallIdentity ;

} MT_CC_RESUME_CONF, * PMT_CC_RESUME_CONF;

#define MT_CC_MAX_USERINFO_SIZE 128
typedef struct
{
    int                 ConnectionId ;
    int                 CallRef ;
    MT_CC_USERINFO      UserInfo ;

} MT_CC_USERINFO_REQ, * PMT_CC_USERINFO_REQ;



// ISDNPT Layer 3 Call States
#define MT_CC_CALL_STATE_IDLE                   0x00000000L
#define MT_CC_CALL_STATE_INITIATED              0x00000001L
#define MT_CC_CALL_STATE_OVERLAP_SENDING        0x00000002L
#define MT_CC_CALL_STATE_OUTGOING_PROC          0x00000003L
#define MT_CC_CALL_STATE_CALL_DELIVERED         0x00000004L
#define MT_CC_CALL_STATE_OVERLAP_RECEIVING      0x00000005L
#define MT_CC_CALL_STATE_PRESENT                0x00000006L
#define MT_CC_CALL_STATE_CALL_RECEIVED          0x00000007L
#define MT_CC_CALL_STATE_CONNECT_REQ            0x00000008L
#define MT_CC_CALL_STATE_INCOMING_PROC          0x00000009L
#define MT_CC_CALL_STATE_ACTIVE                 0x0000000AL
#define MT_CC_CALL_STATE_DISC_REQ               0x0000000BL
#define MT_CC_CALL_STATE_DISC_IND               0x0000000CL
#define MT_CC_CALL_STATE_RELEASE_REQ            0x0000000DL
#define MT_CC_CALL_STATE_SUSPEND_REQ            0x0000000EL
#define MT_CC_CALL_STATE_RESUME_REQ             0x0000000FL

// Cause values
#define MT_CC_CAUSE_UNASSIGNED_NUMBER           0x00000001
#define MT_CC_CAUSE_NO_ROUTE                    0x00000002
#define MT_CC_CAUSE_CHANNEL_UNACCEPTABLE        0x00000006
#define MT_CC_CAUSE_NORMAL_CLEARING             0x00000010
#define MT_CC_CAUSE_USER_BUSY                   0x00000011
#define MT_CC_CAUSE_NO_USER_RESPONDING          0x00000012
#define MT_CC_CAUSE_USER_ALERTING_NO_ANSWER     0x00000013
#define MT_CC_CAUSE_CALL_REJECTED               0x00000015
#define MT_CC_CAUSE_NUMBER_CHANGED              0x00000016
#define MT_CC_CAUSE_NON_SELECTED_USER_CLEARING  0x0000001A
#define MT_CC_CAUSE_DEST_OUT_OF_ORDER           0x0000001B
#define MT_CC_CAUSE_INVALID_NUMBER_FORMAT       0x0000001C
#define MT_CC_CAUSE_FACILITY_REJECTED           0x0000001D
#define MT_CC_CAUSE_RESP_TO_STAT_ENQ            0x0000001E
#define MT_CC_CAUSE_UNSPECIFIED_CAUSE           0x0000001F
#define MT_CC_CAUSE_NO_CIRCUIT_AVAILABLE        0x00000022
#define MT_CC_CAUSE_NETWORK_OUT_OF_ORDER        0x00000026
#define MT_CC_CAUSE_TEMPORARY_FAILURE           0x00000029
#define MT_CC_CAUSE_NETWORK_CONGESTION          0x0000002A
#define MT_CC_CAUSE_ACCESS_INFO_DISCARDED       0x0000002B
#define MT_CC_CAUSE_REQ_CHANNEL_NOT_AVAIL       0x0000002C
#define MT_CC_CAUSE_PRE_EMPTED                  0x0000002D
#define MT_CC_CAUSE_FACILITY_NOT_SUBSCRIBED     0x00000032
#define MT_CC_CAUSE_OUTGOING_CALL_BARRED        0x00000034
#define MT_CC_CAUSE_INCOMING_CALL_BARRED        0x00000036
#define MT_CC_CAUSE_BEAR_CAP_NOT_AUTH           0x00000039
#define MT_CC_CAUSE_BEAR_CAP_NOT_AVAIL          0x0000003A
#define MT_CC_CAUSE_SERVICE_NOT_AVAIL           0x0000003F
#define MT_CC_CAUSE_CAP_NOT_IMPLEMENTED         0x00000041
#define MT_CC_CAUSE_CHAN_NOT_IMPLEMENTED        0x00000042
#define MT_CC_CAUSE_FACILITY_NOT_IMPLEMENT      0x00000045
#define MT_CC_CAUSE_INVALID_CALL_REF            0x00000051
#define MT_CC_CAUSE_CHAN_DOES_NOT_EXIST         0x00000052
#define MT_CC_CAUSE_INCOMPATIBLE_DEST           0x00000058
#define MT_CC_CAUSE_INVALID_MSG_UNSPEC          0x0000005F
#define MT_CC_CAUSE_MANDATORY_IE_MISSING        0x00000060
#define MT_CC_CAUSE_NONEXISTENT_MSG             0x00000061
#define MT_CC_CAUSE_WRONG_MESSAGE               0x00000062
#define MT_CC_CAUSE_BAD_INFO_ELEM               0x00000063
#define MT_CC_CAUSE_INVALID_ELEM_CONTENTS       0x00000064
#define MT_CC_CAUSE_WRONG_MSG_FOR_STATE         0x00000065
#define MT_CC_CAUSE_TIMER_EXPIRY                0x00000066
#define MT_CC_CAUSE_MANDATORY_IE_LEN_ERR        0x00000067
#define MT_CC_CAUSE_PROTOCOL_ERROR              0x0000006F
#define MT_CC_CAUSE_DEVICE_FAILURE              0x00000070

#define MT_CC_DASS_NUMBER_UNOBTAINABLE          0x00000000
#define MT_CC_DASS_ADDRESS_INCOMPLETE           0x00000001
#define MT_CC_DASS_NETWORK_TERMINATION          0x00000002
#define MT_CC_DASS_SERVICE_UNAVAILABLE          0x00000003
#define MT_CC_DASS_SUB_INCOMPLETE               0x00000004
#define MT_CC_DASS_SUB_CHANGED_NUMBER           0x00000005
#define MT_CC_DASS_INALID_SS_REQUEST            0x00000006
#define MT_CC_DASS_CONGESTION                   0x00000007
#define MT_CC_DASS_SUB_ENGAGED                  0x00000008
#define MT_CC_DASS_SUB_OUT_OF_SERVICE           0x00000009
#define MT_CC_DASS_SUB_INCALL_BARRED            0x0000000A
#define MT_CC_DASS_SUB_OUTALL_BARRED            0x0000000B
#define MT_CC_DASS_REMOTE_PROC_ERROR            0x00000012
#define MT_CC_DASS_SERVICE_INCOMPATIBLE         0x00000013
#define MT_CC_DASS_ACKNOWLEDGEMENT              0x00000014
#define MT_CC_DASS_SIGNAL_UNKNOWN               0x00000015
#define MT_CC_DASS_MESSAGE_UNKNOWN              0x0000001A
#define MT_CC_DASS_NAE_ERROR                    0x0000001E
#define MT_CC_DASS_NO_SUB_REPLY                 0x0000001F
#define MT_CC_DASS_SERVICE_TERMINATION          0x00000020
#define MT_CC_DASS_ACCESS_BARRED                0x00000029
#define MT_CC_DASS_DTE_CTRLED_NOT_READY         0x0000002D
#define MT_CC_DASS_DTE_UNCTRLED_NOT_READY       0x0000002E
#define MT_CC_DASS_SUB_TERMINATION              0x00000030
#define MT_CC_DASS_ET_ISOLATED                  0x00000032
#define MT_CC_DASS_LOCAL_PROC_ERROR             0x00000033

// Passive Data Link States
#define MT_DL_UNRESOLVED                0x00000000
#define MT_DL_ACTIVATED                 0x00000001
#define MT_DL_CPE_CONNECTING            0x00000002
#define MT_DL_CO_CONNECTING             0x00000003
#define MT_DL_ESTABLISHED               0x00000004
#define MT_DL_CO_RELEASING              0x00000005
#define MT_DL_CPE_RELEASING             0x00000006

// Call Control stats
typedef struct
{
    ULONG       CallsCnt ;      // Total Calls
    ULONG       ConnectedCalls; // Total Connected Calls
    ULONG       StatusMsgCnt ;  // Total Status Messages
    ULONG       BadSetupCnt ;   // Incorrect SetupMessage Count
    ULONG       BadConnectCnt ; // Incorrect ConnectMessage Count
    ULONG       LastSetupErr ;  // Last SetupMessage Error
    ULONG       LastConnectErr ;// Last ConnectMessage Error
} CC_STATISTICS, * PCC_STATISTICS;

typedef struct
{
    CC_STATISTICS   InCallStats ;
    CC_STATISTICS   OutCallStats ;
} MT_CC_STATS, * PMT_CC_STATS;

// Data Link Stats
typedef struct
{
    ULONG       SabmeCnt ;
    ULONG       DiscCnt ;
    ULONG       RnRCnt ;
    ULONG       FrmrCnt ;
    ULONG       Ns_ErrCnt ;
    ULONG       CrBitErrCnt ;
} DL_STATISTICS, * PDL_STATISTICS;

typedef struct
{
    DL_STATISTICS   InDlStats ;
    DL_STATISTICS   OutDlStats ;
} MT_DL_STATS, * PMT_DL_STATS;

// Physical Layer Stats
typedef struct
{
    ULONG       RxOverflowCnt ;
    ULONG       InvalidFramesCnt ;
    ULONG       ValidFramesCnt;
} PHY_STATISTICS, * PPHY_STATISTICS;

typedef struct
{
    PHY_STATISTICS   InPhyStats ;
    PHY_STATISTICS   OutPhyStats ;
} MT_PHY_STATS, * PMT_PHY_STATS;

#endif

// End of NTiDataCC.h
