#ifndef _SPEAK_H_
#define _SPEAK_H_ 1

#include "..\TFServer\ivr_defs.h"
#include "..\TFServer\log.h"

#ifdef __DLL__
#define SPEAKLIBAPI __declspec(dllexport)
#else
#define SPEAKLIBAPI __declspec(dllimport)
#endif

// Speak constants
// ---------------

#define AM  0
#define PM  1

enum SPEAK_FORMAT_TYPE {
     SPKFMT_DIGITS
   , SPKFMT_NUMBER
   , SPKFMT_DATE
   , SPKFMT_12HOUR
   , SPKFMT_24HOUR
   , SPKFMT_MONEY
   , SPKFMT_ALPHA
   , SPKFMT_MONTHYEAR
   , SPKFMT_MONTHDAY
};

#define SPEAK_ENGLISH   0
#define SPEAK_FRENCH    1

// Function prototypes
// -------------------

// This function needs to be exported to allow WAVEngine access.
bool SPEAKLIBAPI BuildSpkList(int lang, const char* string, int* msgList, SPEAK_FORMAT_TYPE spkFormat);

bool SPEAKLIBAPI getSpeakMsg (int lang, int msgNum, int msgType,
                              char *msgString, const char *fileExt);
void DisplaySpkList (Log *ivLog, int lang, int *msgList);


// Message number constants
// ------------------------

#define SPEAK_ZERO          0
#define SPEAK_ONE           1
#define SPEAK_TWO           2
#define SPEAK_THREE         3
#define SPEAK_FOUR          4
#define SPEAK_FIVE          5
#define SPEAK_SIX           6
#define SPEAK_SEVEN         7
#define SPEAK_EIGHT         8
#define SPEAK_NINE          9
#define SPEAK_TEN          10
#define SPEAK_ELEVEN       11
#define SPEAK_TWELVE       12
#define SPEAK_THIRTEEN     13
#define SPEAK_FOURTEEN     14
#define SPEAK_FIFTEEN      15
#define SPEAK_SIXTEEN      16
#define SPEAK_SEVENTEEN    17
#define SPEAK_EIGHTEEN     18
#define SPEAK_NINETEEN     19
#define SPEAK_TWENTY       20
#define SPEAK_THIRTY       21
#define SPEAK_FORTY        22
#define SPEAK_FIFTY        23
#define SPEAK_SIXTY        24
#define SPEAK_SEVENTY      25
#define SPEAK_EIGHTY       26
#define SPEAK_NINETY       27
#define SPEAK_HUNDRED      28
#define SPEAK_THOUSAND     29
#define SPEAK_MILLION      30
#define SPEAK_BILLION      31
#define SPEAK_TRILLION     32
#define SPEAK_JANUARY      33
#define SPEAK_FEBRUARY     34
#define SPEAK_MARCH        35
#define SPEAK_APRIL        36
#define SPEAK_MAY          37
#define SPEAK_JUNE         38
#define SPEAK_JULY         39
#define SPEAK_AUGUST       40
#define SPEAK_SEPTEMBER    41
#define SPEAK_OCTOBER      42
#define SPEAK_NOVEMBER     43
#define SPEAK_DECEMBER     44
#define SPEAK_SECONDS      45
#define SPEAK_MINUS        46
#define SPEAK_DOLLAR       47
#define SPEAK_DOLLARS      48
#define SPEAK_CENT         49
#define SPEAK_CENTS        50
#define SPEAK_AND          51
#define SPEAK_FIRST        52
#define SPEAK_SECOND       53
#define SPEAK_THIRD        54
#define SPEAK_FOURTH       55
#define SPEAK_FIFTH        56
#define SPEAK_SIXTH        57
#define SPEAK_SEVENTH      58
#define SPEAK_EIGHTH       59
#define SPEAK_NINTH        60
#define SPEAK_TENTH        61
#define SPEAK_ELEVENTH     62
#define SPEAK_TWELFTH      63
#define SPEAK_THIRTEENTH   64
#define SPEAK_FOURTEENTH   65
#define SPEAK_FIFTEENTH    66
#define SPEAK_SIXTEENTH    67
#define SPEAK_SEVENTEENTH  68
#define SPEAK_EIGHTEENTH   69
#define SPEAK_NINETEENTH   70
#define SPEAK_TWENTIETH    71
#define SPEAK_THIRTIETH    72
#define SPEAK_PAUSE        73
#define SPEAK_OCLOCK       74
#define SPEAK_AM           75
#define SPEAK_PM           76
#define SPEAK_OH           77
#define SPEAK_POINT        78
#define SPEAK_MONDAY       79
#define SPEAK_TUESDAY      80
#define SPEAK_WEDNESDAY    81
#define SPEAK_THURSDAY     82
#define SPEAK_FRIDAY       83
#define SPEAK_SATURDAY     84
#define SPEAK_SUNDAY       85
#define SPEAK_AT           86
#define SPEAK_HOURS        87
#define SPEAK_A            88
#define SPEAK_B            89
#define SPEAK_C            90
#define SPEAK_D            91
#define SPEAK_E            92
#define SPEAK_F            93
#define SPEAK_G            94
#define SPEAK_H            95
#define SPEAK_I            96
#define SPEAK_J            97
#define SPEAK_K            98
#define SPEAK_L            99
#define SPEAK_M           100
#define SPEAK_N           101
#define SPEAK_O           102
#define SPEAK_P           103
#define SPEAK_Q           104
#define SPEAK_R           105
#define SPEAK_S           106
#define SPEAK_T           107
#define SPEAK_U           108
#define SPEAK_V           109
#define SPEAK_W           110
#define SPEAK_X           111
#define SPEAK_Y           112
#define SPEAK_Z           113
#define SPEAK_ZEE         114
#define SPEAK_EXCLAIM     115           // Exclamation point
#define SPEAK_DQUOTE      116           // Double quote
#define SPEAK_POUND       117           // Pound sign
#define SPEAK_DOLLARSIGN  118           // Dollar sign
#define SPEAK_PERCENT     119           // Percent sign
#define SPEAK_AMPERSAND   120           // Ampersand
#define SPEAK_SQUOTE      121           // Single quote
#define SPEAK_OPENPAREN   122           // Open parentheses
#define SPEAK_CLOSEPAREN  123           // Close parentheses
#define SPEAK_ASTERISK    124           // Asterisk
#define SPEAK_PLUS        125           // Plus sign
#define SPEAK_COMMAN      126           // Comma
#define SPEAK_HYPHEN      127           // Hyphen
#define SPEAK_PERIOD      128           // Period
#define SPEAK_FWDSLASH    129           // Forward slash
#define SPEAK_COLON       130           // Colon
#define SPEAK_SEMICOLON   131           // Semicolon
#define SPEAK_LESSTHAN    132           // Less than symbol
#define SPEAK_EQUAL       133           // Equal sign
#define SPEAK_GREATERTHAN 134           // Greater than symbol
#define SPEAK_QUESTION    135           // Question mark
#define SPEAK_ATSIGN      136           // At sign
#define SPEAK_OPENBRACK   137           // Open square bracket
#define SPEAK_BACKSLASH   138           // Back slash
#define SPEAK_CLOSEBRACK  139           // Close square bracket
#define SPEAK_CARET       140           // Caret
#define SPEAK_UNDERSCORE  141           // Underscore
#define SPEAK_GRAVE       142           // Grave accent
#define SPEAK_OPENBRACE   143           // Open brace
#define SPEAK_VERTBAR     144           // Vertical bar (line)
#define SPEAK_CLOSEBRACE  145           // Close brace
#define SPEAK_TILDE       146           // Tilde
#define SPEAK_MINUTE      147
#define SPEAK_MINUTES     148

#undef SPEAKLIBAPI

#endif
