#ifndef STEP_HTTP_H
#define STEP_HTTP_H

#include "..\inet\HTTPTransaction.h"
#include "step.h"

class StepHTTP : public Step
{
   public:

      StepHTTP(STEPREC& stepRecord);
      StepHTTP(void);
      virtual ~StepHTTP(void);

		const char* GetStepName(void) const;

      IV_STATUS Execute(PIVRINFO pInfo);

      void SetRequestBody(const char* value);
      void SetRequestType(HTTPRequest::REQUEST_METHOD value);
      void SetResponseBodyVar(const char* value);
      void SetResponseHeaderVar(const char* value);
      void SetTimeout(const char* value);
      void SetURL(const char* value);
      void SetMessageCode(const char* value);
      void SetFileName(const char* value);
      void SetFileType(int value);
      void SetConnectionTimeout(const char* value);
      void SetConnectionRetries(const char* value);

   protected:

      string requestBody;
      HTTPRequest::REQUEST_METHOD requestMethod;
      string responseBodyVar;
      string responseHeaderVar;
      string timeout;
      string URL;
      string msgCd;
      string fileNm;
      SOUND_FORMAT format;
      string connectionTimeout;
      string connectionRetries;
      STEPREC uninitialisedStepRecord;
};

#endif
