#ifndef STEP_SAVELOG_H
#define STEP_SAVELOG_H

#include "step.h"

class StepSaveLog : public Step
{
   public:

      StepSaveLog(STEPREC& stepRecord);
      virtual ~StepSaveLog(void);

		const char* GetStepName(void) const;

      IV_STATUS Execute(PIVRINFO pInfo);

   protected:

      // ------------------------------------------------
      // (u1)  Save to Teleflow log folder
      // (  )  Save to folder:   [_____ s1 _____]
      //
      // (u2)  Use TeleFlow log name
      // (  )  Specify log name: [_____ s2 _____]
      //       (Note: port number and date stamp will
      //        automatically be appended to file name)
      // ------------------------------------------------
      //
      // U1 = code for location to log to (TF Log folder or other)
      // U2 = code for log name (use TF Log name or other)
      // S1 = Folder to save log to (if U1 != TF Log folder)
      // S2 = log name (if U2 != TF Log name)
      //
      bool   bSpecifiedLogFolder;   // u1
      bool   bSpecifiedLogName;     // u2
      string folderName;            // s1
      string fileName;              // s2
};

#endif
