#include "step_vardateinfo.h"

StepVarDateInfo::StepVarDateInfo(STEPREC& stepRecord) : Step(stepRecord)
{
   bUpperCase = (bool) stepRecord.u2;
   varA = stepRecord.s1.arr;
   varB = stepRecord.s2.arr;
   switch(stepRecord.u1)
   {
      case 1: iFn = FN_WEEKDAY_SHORT; break;
      case 2: iFn = FN_WEEKDAY_LONG;  break;
      case 3: iFn = FN_MONTH_SHORT;   break;
      case 4: iFn = FN_MONTH_LONG;    break;
      default:  iFn = FN_WEEKDAY_SHORT;
   }
}

StepVarDateInfo::~StepVarDateInfo(void)
{
}

const char* StepVarDateInfo::GetStepName(void) const
{
	return("Date Info");
}

IV_STATUS StepVarDateInfo::Execute (PIVRINFO pInfo)
{
   char* date;
   IV_STATUS status;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((date = pInfo->variables->ParseParameter("Date", varB.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   status = VarDateInfo(pInfo, varA.c_str(), date, iFn, bUpperCase);

   delete[] date;

   return(status);
}
