#include "step_vocrecrelease.h"
#include "..\BoardDLLs\brd_generic.h"
#include "VoiceCreator.h"

StepVocRecRelease::StepVocRecRelease(STEPREC& stepRecord) : Step(stepRecord)
{
}

StepVocRecRelease::~StepVocRecRelease(void)
{
}

const char* StepVocRecRelease::GetStepName(void) const
{
	return("SR Release");
}

IV_STATUS StepVocRecRelease::Execute(PIVRINFO pInfo)
{
   IV_STATUS status;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   if(pInfo->speechRecognition == NULL)
   {
      return(IVR_SUCCESS);
   }

   status = pInfo->ivBoard->PermitBargeIn(false);

   if(pInfo->speechRecognition->SRRelease() != IVR_SUCCESS)
   {
      pInfo->ivLog->Print("   ERROR: Unable to release speech recognition resource\n");
      return(IVR_FAIL);
   }

   // Remove previous voice module
   if((pInfo->speechRecognitionLibrary != NULL))
   {
      if((pInfo->speechRecognition != pInfo->voiceAuthentication) &&
         (pInfo->speechRecognition != pInfo->textToSpeech))
      {
         PVoiceDestroyer voiceDestroyer = GetVoiceDestroyer(pInfo->speechRecognitionLibrary);

         if(voiceDestroyer != NULL)
         {
            voiceDestroyer(pInfo->speechRecognition);
         }
      }
   }
   pInfo->speechRecognition = NULL;
   pInfo->speechRecognitionLibrary = NULL;

   return(status);
}
