#ifndef TAM_H
#define TAM_H

#include "..\TFServer\ivr_defs.h"
#include "step.h"

/* -------------------------------------------------------------------------
   Class:       TAM
   ------------------------------------------------------------------------- */
class TAM : public Link
{
   public:

      enum state { good = 0, bad = 1, badname = 2, notfound = 3 };
      
      TAM(Log* outLog, bool logDisabled, const char* procName, int portnum);
      ~TAM(void);

      const char* GetName(void) const;
      const char* GetShortName(void) const;
      IV_STATUS LoadSteps(void);
      Step* GetFirstStep(void);
      Step* GetStep (int cStep);
      Step* GetLabelStep (const char *label);
      void SetTAMID (int value);
      int GetTAMID(void) const;
      state GetState(void) const;
      bool IsLogDisabled(void) const;

   private:

      Log*   ivLog;
      Steps* steps;
      state  myState;
      char*  pszName;
      char*  pszShortName;
      int    iPort;
      int    iTAMID;
      bool   logDisabled;

      // private copy constructor and operator= (define these and make them
      // public to enable copy and assignment of the class)
      TAM(const TAM&);
      TAM& operator=(const TAM&);
};

#endif
