#ifndef TXTFILE_H
#define TXTFILE_H

#include "..\TFServer\ivr_defs.h"
#include "..\TFServer\log.h"

#define APP_TYPE  "TAP"
#define MOD_TYPE  "TAM"

#define DESIGNVER "0200"    // Version of Designer TAP/TAM's expected by Engine

typedef struct {
   int   len;
   char *arr;
} MYCHAR;

typedef struct {
   int      op;
   MYCHAR   label;
   int      current;
   int      next;
   int      attrib;
   int      parent;
   MYCHAR   s1;
   MYCHAR   s2;
   MYCHAR   s3;
   MYCHAR   s4;
   MYCHAR   s5;
   int      u1;
   int      u2;
   int      u3;
   int      u4;
   MYCHAR   s6;
   // New fields - TF May 22/97
   int      u5;
   int      u6;
   int      u7;
   int      u8;
   MYCHAR   s7;
   MYCHAR   s8;
   MYCHAR   s9;
   MYCHAR   s10;
} STEPREC, *PSTEPREC;

IV_STATUS IvOpenFile (Log *ivLog, FILE **fp, const char *filename);
IV_STATUS IvCloseFile (Log *ivLog, FILE **fp, const char *filename);

IV_STATUS TxtFetchStep (FILE *fp, PSTEPREC stepRec);
IV_STATUS TxtNextRecord (FILE *fp);
IV_STATUS TxtSkipSection (FILE *fp);
int TxtReadNumber (FILE *fp, int *num);
void TxtSetupStepRecMemory (PSTEPREC stepRec);
void TxtFreeStepRecMemory (STEPREC *stepRec);
int TxtReadString (FILE *fp, MYCHAR *s);
int TxtReadField (FILE *fp, char *s);
IV_STATUS TxtApplHeader (Log *ivLog, const char *appDb);
IV_STATUS TxtModuleHeader (FILE *fproc);
IV_STATUS TxtGenericHeader (Log *ivLog, FILE *fproc, char *ftype);
bool DefaultExt (MYCHAR *path, const char *ext);
bool ChangePath (char *path);

#endif
