#ifndef LOADLICENSE_H
#define LOADLICENSE_H

#include "..\TFServer\ivrinfo.h"
#include "..\TFServer\license_read.h"

class LICENSE_INFO
{
   public:
      LICENSE_INFO(void);
      ~LICENSE_INFO(void);

      // Loads the license module DLL, and maps to relevant functions
      bool LoadLicenseModule(void);

      // Accessor methods to retrieve the license info from private members
      const LICENSE_STATUS GetLicenseStatus(void) const;
      const int GetNumPorts(void) const;
      const int GetNumDays(void) const;

   private:
      TFLICENSESTRUCT licenseData;        // data known about the current TeleFlow license
      HINSTANCE       hLibrary;           // Handle to the TeleFlow license library (DLL)
      typedef TFLICENSESTRUCT (* lpFuncGetLicense)();
      lpFuncGetLicense dllGetLicense;    // Pointer to function in DLL to get the TF License information

      // Maps appropriate handles to the functions in the TF License Module
      bool LoadLicenseFunctions(void);
      bool GetLicenseData(TFLICENSESTRUCT* pData);

};


#endif
